      real function AbsVec(v)
      implicit none
      real v(3)
      AbsVec = sqrt(v(1)**2 + v(2)**2 + v(3)**2)
      return
      end
      subroutine AddVecUniqueI(v,vlist,ntot,npos,new)
      integer v(3)
      integer vlist(3,*)
      integer ntot
      integer npos
      logical new
      call PosVecI(v,vlist,ntot,npos)
      if(npos.ne.0) then
        new = .false.
        return
      else
        ntot = ntot + 1
        call saveVecI(v,vlist,ntot)
        npos = ntot
        new = .true.
      endif
      return
      end
      real function AngV2(v,w)
      implicit none
      real v(3)
      real w(3)
      real AbsVec
      real ScalProd
      real av
      real aw
      real arg
      av = AbsVec(v)
      aw = AbsVec(w)
      if(av.lt.1.0e-7.or.aw.lt.1.0e-7) then
        call str_write(6,'|v| or |w| < 1.0e-10 in AngV2')
        pause 'Type CONTINUE to accept 0 as result or EXIT to abort'
        AngV2 = 0.0
      else
        arg = ScalProd(v,w)/(av*aw)
        if(arg.gt.1.0) arg = 1.0
        if(arg.lt.-1.0) arg = -1.0
        AngV2 = acos(arg)
      endif
      return
      end
      subroutine append_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      integer   lenstr
      character filename*256
      integer   lf
      filename = fn
      lf = lenstr(filename)
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_string(filename,'No free unit in append_file',message)
        return
      endif
      open(unit=unit,file=filename(1:lf),status='unknown',
     1 iostat=error,access='append')
      if(error.ne.0) then
        message = 'Error # appending #'
        call str_integer(error,message,message)
        call str_string(filename,message,message)
      else
        message = 'Appending '//filename(1:lf)
      endif
      return
      end ! append_file
      subroutine Build_file(in,name,typ,outfinal,lo)
      implicit none
      character IN*(*)         !I: inputfilename
      character NAME*(*)       !I: name if inputfilename is nameless
      character TYP*(*)        !I: type if inputfilename is typeless
      character OUTFINAL*(*)   !O: result
      integer   LO             !O: length out
      integer   length
      character string*256
      integer   ls
      integer   ip
      character out*256
      ip = 0
      call filescan(IN,'PATH',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'NAME',string,ls)
      if(ls.eq.0) then
        ls = length(NAME)
        if(ls.gt.0) string = NAME(1:ls)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'TYPE',string,ls)
      if(ls.le.1) then
        if(length(TYP).eq.0) then
          string = '.'
          ls = 0
        else
          if(TYP(1:1).eq.'.') then
            string = TYP
          else
            string = '.'//TYP
          endif
          ls = length(string)
        endif
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'VERSION',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      outfinal = out
      LO = ip
      return
      end ! build_file
      subroutine build_file_type(IN,NAME,TYP,OUTFINAL,LO)
      implicit none
      character IN*(*)         !I: inputfilename
      character NAME*(*)       !I: name if inputfilename is nameless
      character TYP*(*)        !I: type
      character OUTFINAL*(*)   !O: result
      integer   LO             !O: length result
      integer   length
      character string*256
      integer   ls
      integer   ip
      character out*256
      ip = 0
      call filescan(IN,'PATH',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'NAME',string,ls)
      if(ls.eq.0) then
        ls = length(NAME)
        if(ls.gt.0) string = name(1:ls)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      if(length(TYP).eq.0) then
        string = '.'
        ls = 0
      else
        if(TYP(1:1).eq.'.') then
          string = TYP
        else
          string = '.'//TYP
        endif
        ls = length(string)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      outfinal = out
      LO = ip
      return
      end ! build_file_type
      subroutine build_matrix(m11,m12,m13,m21,m22,m23,m31,m32,m33,m)
      implicit none
      real m11,m12,m13
      real m21,m22,m23
      real m31,m32,m33
      real m(3,3)
      m(1,1) = m11
      m(1,2) = m12
      m(1,3) = m13
      m(2,1) = m21
      m(2,2) = m22
      m(2,3) = m23
      m(3,1) = m31
      m(3,2) = m32
      m(3,3) = m33
      return
      end
      subroutine build_vector(v1,v2,v3,v)
      implicit none
      real v1
      real v2
      real v3
      real v(3)
      v(1) = v1
      v(2) = v2
      v(3) = v3
      return
      end
      subroutine ccaction_pop
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      if (stackp.eq.0) then
        print *,'DBG> CC Stack underflow'
        action=0
        return
      end if
      action=stack(stackp)
      stackp=stackp-1
      return
      end
      subroutine ccaction_print
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      integer i
      call str_flush
      do i=1,stackp
        call str_2integer_out(i,stack(i),'stack(#)=#')
      enddo
      call str_integer_out(action,'action=#')
      call str_flush
      return
      end
      subroutine ccaction_push(i)
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      integer i
      if (stackp.eq.10) then
        print *,'DBG> CC Stack overflow'
        call ccaction_print
        action=i
        return
      end if
      stackp=stackp+1
      stack(stackp)=action
      action=i
      return
      end
      subroutine ccself
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      selfinterrupt = selfinterrupt + 1
      return
      end
      subroutine CellDim(d,a,al)
      implicit none
      real d(3,3)
      real a(3)
      real al(3)
      real absvec
      real scalprod
      real v1(3)
      real v2(3)
      real v3(3)
      call Row2Vec(1,d,v1)
      call Row2Vec(2,d,v2)
      call Row2Vec(3,d,v3)
      a(1)  = absvec(v1)
      a(2)  = absvec(v2)
      a(3)  = absvec(v3)
      al(1) = acos( scalprod(v2,v3)/(a(2)*a(3)) )
      al(2) = acos( scalprod(v3,v1)/(a(3)*a(1)) )
      al(3) = acos( scalprod(v1,v2)/(a(1)*a(2)) )
      return
      end
      subroutine CellDimStar(r,as,als)
      implicit none
      real r(3,3)
      real as(3)
      real als(3)
      real absvec
      real scalprod
      real v1(3)
      real v2(3)
      real v3(3)
      call Col2Vec(1,r,v1)
      call Col2Vec(2,r,v2)
      call Col2Vec(3,r,v3)
      as(1)  = absvec(v1)
      as(2)  = absvec(v2)
      as(3)  = absvec(v3)
      als(1) = acos( scalprod(v2,v3)/(as(2)*as(3)) )
      als(2) = acos( scalprod(v3,v1)/(as(3)*as(1)) )
      als(3) = acos( scalprod(v1,v2)/(as(1)*as(2)) )
      return
      end
      subroutine Col2Vec(coln,m,v)
      implicit none
      integer coln
      real    m(3,3)
      real    v(3)
      integer i
      do i=1,3
        v(i) = m(i,coln)
      enddo
      return
      end
      subroutine config_path(path,lp)
      implicit none
      character path*(*)
      integer   lp
      integer   length
      character name*80
      integer   ln
      character configname*80
      integer   lcn
      logical   exist
      character line*80
      integer   ll
      call image_name(name,ln)
      call get_logical(name,line)
      ll = length(line)
      if(ll.eq.0) then
        call build_file('/usr/local/lib/',name(1:ln),' ',
     1   configname,lcn)
        inquire(file=configname(1:lcn),exist=exist)
        if(exist) then
          path = configname(1:lcn)//'/'
          lp = lcn+1
        else
          call build_file('/usr/global/lib/',name(1:ln),' ',
     1     configname,lcn)
          inquire(file=configname(1:lcn),exist=exist)
          if(exist) then
            path = configname(1:lcn)//'/'
            lp = lcn+1
          else
            call image_path(path,lp)
          endif
        endif
      else
        if(line(ll:ll).eq.'/') then
          path = line(1:ll)
          lp = ll
        else
          path = line(1:ll)//'/'
          lp = ll + 1
        endif
      endif
      return
      end ! config_path
      subroutine CopyMat(r,s)
      implicit none
      real r(3,3)
      real s(3,3)
      integer i
      integer j
      do j=1,3
        do i=1,3
          s(i,j) = r(i,j)
        enddo
      enddo
      return
      end
      subroutine copystr(s1,s2)
      character s1*(*)
      character s2*(*)
      integer   L
      L = min(len(s1),len(s2))
      s2 = s1(1:L)
      return
      end                       ! copystr
      subroutine CopyVec(u,v)
      implicit none
      real u(3)
      real v(3)
      integer i
      do i=1,3
        v(i) = u(i)
      enddo
      return
      end
      subroutine CopyVecFI(u,v)
      implicit none
      real    u(3)
      integer v(3)
      integer i
      do i=1,3
        v(i) = nint(u(i))
      enddo
      return
      end
      subroutine CopyVecI(u,v)
      implicit none
      integer u(3)
      integer v(3)
      integer i
      do i=1,3
        v(i) = u(i)
      enddo
      return
      end
      subroutine CopyVecIF(u,v)
      implicit none
      integer u(3)
      real    v(3)
      integer i
      do i=1,3
        v(i) = float(u(i))
      enddo
      return
      end
      character*13 function cputime()
      implicit none
      character sec2time*13
      real      second
      external  second
      character c*13
      c = sec2time(second())
      cputime = c
      return
      end                       ! cputime
      subroutine create_directory(string,ier)
      implicit none
      character string*(*)
      integer   ier
      integer   lenstr
      character s*256
      integer   ls
      s = string
      ls = lenstr(s)
      call spawn('mkdir '//s(1:ls),ier)
      return
      end ! create_directory
      subroutine create_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      integer   lenstr
      logical   overwrite
      common /common___files/ overwrite
      character filename*256
      integer   lf
      data overwrite /.false./
      filename = fn
      lf = lenstr(filename)
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_string(filename,'No free unit in create_file #',
     1  message)
        return
      endif
      if(.not.overwrite) then
        call rename_unique_file(filename(1:lf))
        open(unit=unit,file=filename(1:lf),status='new',iostat=error)
      else
        open(unit=unit,file=filename(1:lf),status='unknown',
     1   iostat=error)
      endif
      if(error.ne.0) then
        message = 'Error # creating #'
        call str_integer(error,message,message)
        call str_string(filename,message,message)
      else
        message = 'Created '//filename(1:lf)
      endif
      return
      end ! create_file
      subroutine create_overwrite(new,old)
      implicit none
      logical new
      logical old
      logical   overwrite
      common /common___files/ overwrite
      logical tmp
      tmp = new
      old = overwrite
      overwrite = tmp
      return
      end ! create_overwrite
      character*20 function datetime()
      implicit none
      character rolex*10
      character today*11
      character roltmp*10
      roltmp=rolex()
      datetime = today()//roltmp(1:9)
      return
      end                       ! datetime
      subroutine delete_file(filename,message,ier)
      implicit none
      character filename*(*)
      character message*(*)
      integer   ier
      integer   unit
      call get_lun(unit,ier)
      if(ier.ne.0) then
        message = 'No free unit in delete_file'
        return
      endif
      open(unit=unit,file=filename,status='old',iostat=ier)
      if(ier.ne.0) then
        message = 'error # opening #'
        call str_integer(ier,message,message)
        call str_string(filename,message,message)
        return
      endif
      close(unit=unit,status='delete',iostat=ier)
      if(ier.ne.0) then
        close(unit)
        message = 'Error # deleting #'
        call str_integer(ier,message,message)
        call str_string(filename,message,message)
        return
      endif
      ier = 0
      message = 'Deleted '//filename
      return
      end                       ! delete_file
      subroutine DifVec(u,v,w)
      implicit none
      real u(3)
      real v(3)
      real w(3)
      integer i
      do i=1,3
        w(i) = u(i) - v(i)
      enddo
      return
      end
      subroutine directory(code,name1,name2,ier) ! sorted
      implicit none
      integer   code
      character name1*(*)
      character name2*(*)
      integer   ier
      integer   maxnn
      parameter (maxnn= 100)
      integer   maxlen
      parameter (maxlen=128)
      integer   length
      integer   n
      integer   nn
      character names(maxnn)*(maxlen)
      logical   filemode
      integer   direrr
      integer   l2
      integer   unit
      character s1*80
      character s2*80
      character command*80
      integer   ls
      character message*256
      integer   i
      character u*80
      save n,nn,names,filemode,unit
      if(code.eq.0) then
        filemode = .false.
        unit = 0 ! prevent compiler warning
        nn = 0
        call directorynosort(0,name1,name2,direrr)
        do while(direrr.eq.0)
          l2 = length(name2)
          nn = nn + 1
          if(filemode) then
            call str_write(unit,name2)
          else
            if(l2.gt.maxlen.or.nn.gt.maxnn) then
              filemode = .true.
              call uniquename(u)
              call str_string(u,'/tmp/dirlis#.out',s1)
              call create_file(s1,unit,message,ier)
              if(ier.ne.0) then
                call str_flush
                call str_write(6,message)
                return
              endif
              do i=1,maxnn
                call str_write(unit,names(i))
              enddo
              call str_write(unit,name2)
            else
              names(nn) = name2
            endif
          endif
          call directorynosort(1,name1,name2,direrr)
        enddo
        call directorynosort(-1,name1,name2,direrr)
        if(nn.gt.0) then
          if(filemode) then
            close(unit)
            call build_file_type(s1,' ','.sor',s2,ls)
            call str_2string(s1,s2,'sort < # > #',command)
            call spawn(command,ier)
            if(ier.ne.0) then
              call str_flush
              call str_string_write(6,command,'Cannot execute #')
              return
            endif
            call delete_file(s1,message,ier)
            if(ier.ne.0) then
              call str_flush
              call str_write(6,message)
              return
            endif
            call open_file(s2,unit,message,ier)
            if(ier.ne.0) then
              call str_flush
              call str_write(6,message)
              return
            endif
          else
            call sort_char(nn,names)
            n = 0
          endif
        else
          ier = 1
          return
        endif
      endif
      if(code.eq.0.or.code.eq.1) then
        n = n + 1
        if(filemode) then
          read(unit,'(A)',iostat=ier) name2
        else
          if(n.le.nn) then
            name2 = names(n)
            ier = 0
          else
            ier = 1
          endif
        endif
      else
        if(filemode) then
          close(unit,status='delete')
        endif
      endif
      return
      end ! directory
      subroutine directorynosort(code,name1,name2,ier)
      implicit none
      integer   code
      character name1*(*)
      character name2*(*)
      integer   ier
      integer   nl2
      character string*512
      integer   ls
      integer   diropen
      integer   dirmatchfile
      character path*512
      integer   lp
      if(code.eq.0) then
        call filescan(name1,'PATH',path,lp)
        if (lp.eq.0) then
          ier = diropen('.')
        else
          ier = diropen(path(1:lp))
        endif
        if (ier.ne.0) return
      endif
      if(code.eq.0.or.code.eq.1) then
        call filescan(name1,'PATH',path,lp)
        call filescan(name1,'FILE',string,ls)
        if (ls.eq.0) then
          ls=1
          string='*'
        endif
   10   continue
        ier=dirmatchfile(string(1:ls),name2,nl2)
        if(ier.eq.0) then
          if(name2(1:1).eq.'.') goto 10
        endif
        if(lp.gt.0.and.ier.eq.0) name2=path(1:lp)//name2(1:nl2)
      else
        call dirlastfile()
      endif
      return
      end ! directorynosort
      subroutine editor(string,ier)
      implicit none
      character string*(*)
      integer   ier
      integer   lenstr
      integer   length
      character s*256
      character e*256
      integer   ls
      integer   le
      s = string
      ls = lenstr(string)
      call getenv('EDITOR',e)
      le=length(e)
      if (le.eq.0) then
        e='vi'
        le=2
      endif
      call spawn(e(1:le)//' '//s(1:ls),ier)
      return
      end ! editor
      real*8 function eval_expression()
      implicit none
      real*8    simple_expression
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      integer   iexp
      common/evl___expression/iexp
      character opr
      common/evl___expression_char/opr(20)
      real*8    e
      common/evl___expression_real/e(20)
      iexp=iexp+1
      eval_expression = 0.0D0 ! init
      if (iexp.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      e(iexp)=simple_expression()
      if (err.gt.0) return
      do while (ch.eq.'+'.or.ch.eq.'-')
        opr(iexp)=ch
        call eval_nextch
        if (opr(iexp).eq.'+') then
          e(iexp)=e(iexp)+simple_expression()
          if (err.gt.0) return
        else
          e(iexp)=e(iexp)-simple_expression()
          if (err.gt.0) return
        endif
      enddo
      eval_expression=e(iexp)
      iexp=iexp-1
      return
      end !eval_expression
      real*8 function eval_factor()
      implicit none
      real*8 Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.141592653589793D0)
      parameter (TwoPi = 2D0*Pi)
      parameter (PiOver2 = Pi / 2.0D0)
      parameter (Grad = 180.0D0/Pi)
      real*8    eval_expression
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      integer   ifac
      integer   start
      common/evl___factor/ifac,start(20)
      real*8    f
      common/evl___factor_real/f(20)
      character line*8
      common/evl___factor_char/line(20)
      character firstnamechars*80
      character namechars*80
      character string*10
      data firstnamechars/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      data namechars/'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_$'/
      eval_factor = 0.0D0 ! init
      ifac=ifac+1
      if (ifac.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      if (ch.ge.'0'.and.ch.le.'9') then                        ! number
        start(ifac)=pos
        do while (ch.le.'9'.and.ch.ge.'0')
          call eval_nextch
        enddo
        if (ch.eq.'.') then
          call eval_nextch
          do while (ch.le.'9'.and.ch.ge.'0')
            call eval_nextch
          enddo
        endif
        if (ch.eq.'E') then
          call eval_nextch
          call eval_nextch
          do while (ch.le.'9'.and.ch.ge.'0')
            call eval_nextch
          enddo
        endif
        call str_integer(pos-start(ifac),'(F#.0)',string)
        read(form(start(ifac):pos-1),string,err=90) f(ifac)
        goto 80
90      continue
        reason='error in constant.'
        err=pos
        return
80      continue
      else
        if (ch.eq.'(') then                                      ! expressie
          call eval_nextch
          f(ifac)=eval_expression()
          if (err.gt.0) return
          if (ch.eq.')') then
            call eval_nextch
          else
            reason='")" expected'
            err=pos
            return
          endif
        else
          if (index(firstnamechars,ch).eq.0) then
            reason='number/func syntax error.'
            err=pos
            return
          endif
          start(ifac)=pos
          do while (index(namechars,ch).gt.0)
            call eval_nextch
          enddo
          line(ifac)=form(start(ifac):pos-1)
          if(line(ifac).eq.'PI') then
            f(ifac) = Pi
          else if(line(ifac).eq.'PIOVER2') then
            f(ifac) = PiOver2
          else if(line(ifac).eq.'TWOPI') then
            f(ifac) = TwoPi
          else if(line(ifac).eq.'GRAD') then
            f(ifac) = Grad
          else if (ch.ne.'(') then
            reason='variable not found'
            err=pos
            return
          else
            call eval_nextch
            f(ifac)=eval_expression()
            if (err.gt.0) return
            if (ch.eq.')') then
              call EVAL_nextch
            else
              reason='")" expected'
              err=pos
              return
            endif
            if (line(ifac)(1:4).eq.'TAND') then
              f(ifac)=tan(f(ifac)/Grad)
            else if (line(ifac)(1:4).eq.'SIND') then
              f(ifac)=sin(f(ifac)/Grad)
            else if (line(ifac)(1:4).eq.'COSD') then
              f(ifac)=cos(f(ifac)/Grad)
            else if (line(ifac)(1:3).eq.'SIN') then
              f(ifac)=sin(f(ifac))
            else if (line(ifac)(1:3).eq.'COS') then
              f(ifac)=cos(f(ifac))
            else if (line(ifac)(1:3).eq.'TAN') then
              f(ifac)=tan(f(ifac))
            else if (line(ifac)(1:5).eq.'ATAND') then
              f(ifac)=atan(f(ifac))*Grad
            else if (line(ifac)(1:5).eq.'ASIND') then
              if (f(ifac).lt.-1d0.or.f(ifac).gt.1d0) then
                reason='asin-argument error'
                err=pos
                return
              endif
              f(ifac)=asin(f(ifac))*Grad
            else if (line(ifac)(1:5).eq.'ACOSD') then
              if (f(ifac).lt.-1d0.or.f(ifac).gt.1d0) then
                reason='acos-argument error'
                err=pos
                return
              endif
              f(ifac)=acos(f(ifac))*grad
            else if (line(ifac)(1:4).eq.'ATAN') then
              f(ifac)=atan(f(ifac))
            else if (line(ifac)(1:4).eq.'ASIN') then
              if (f(ifac).lt.-1d0.or.f(ifac).gt.1d0) then
                reason='asin-argument error'
                err=pos
                return
              endif
              f(ifac)=asin(f(ifac))
            else if (line(ifac)(1:4).eq.'ACOS') then
              if (f(ifac).lt.-1d0.or.f(ifac).gt.1d0) then
                reason='acos-argument error'
                err=pos
                return
              endif
              f(ifac)=acos(f(ifac))
            else if (line(ifac)(1:4).eq.'SQRT') then
              if (f(ifac).lt.0d0) then
                reason='sqrt-argument error'
                err=pos
                return
              endif
              f(ifac)=sqrt(f(ifac))
            else if (line(ifac)(1:3).eq.'EXP') then
              if (f(ifac).gt.85.6d0) then
                reason='exp-argument error'
                err=pos
                return
              endif
              f(ifac)=exp(f(ifac))
            else if (line(ifac)(1:5).eq.'LOG10') then
              if (f(ifac).lt.0d0) then
                reason='log10-argument error'
                err=pos
                return
              endif
              f(ifac)=log10(f(ifac))
            else if (line(ifac)(1:3).eq.'LOG') then
              if (f(ifac).lt.0d0) then
                reason='log-argument error'
                err=pos
                return
              endif
              f(ifac)=log(f(ifac))
            else if (line(ifac)(1:3).eq.'INT') then
              f(ifac)=dble(int(f(ifac)))
            else if (line(ifac)(1:4).eq.'NINT') then
              f(ifac)=dble(nint(f(ifac)))
            else
              reason='unknown function'
              err=pos
              return
            endif
          endif
        endif
      endif
      eval_factor=f(ifac)
      ifac=ifac-1
      return
      end !  eval_factor
      subroutine eval_nextch
      implicit none
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      character eofline
      character tab
      eofline = char(13)
      tab = char(9)
10    continue
      pos=pos+1
      if (pos.le.lF) then
        ch=form(pos:pos)
      else
        ch=eofline
      endif
      if (ch.eq.' '.or.ch.eq.tab) goto 10
      return
      end ! eval_nextch
      real*8 function eval_term()
      implicit none
      real*8    signedfactor
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      integer   iter
      common/evl___term/iter
      real*8    t
      common/evl___term_real/t(20)
      eval_term = 0.0D0 ! init
      iter=iter+1
      if (iter.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      t(iter)=signedfactor()
      if (err.gt.0) return
      do while (ch.eq.'^')
        call eval_nextch
        t(iter)=exp(log(t(iter))*signedfactor())
        if (err.gt.0) return
      enddo
      eval_term=t(iter)
      iter=iter-1
      return
      end ! eval_term
      subroutine evaluate8(formula,value,errpos,reasonret)
      implicit none
      character formula*(*)
      real*8    value
      integer   errpos
      character reasonret*(*)
      integer   length
      real*8    eval_expression
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      integer   ifac
      integer   start
      common/evl___factor/ifac,start(20)
      real*8    f
      common/evl___factor_real/f(20)
      character line*8
      common/evl___factor_char/line(20)
      integer   iexp
      common/evl___expression/iexp
      character opr
      common/evl___expression_char/opr(20)
      real*8    e
      common/evl___expression_real/e(20)
      integer   isim
      common/evl___simple/isim
      real*8    s
      real*8    s2
      common/evl___simple_real/s(20),s2(20)
      character ops
      common/evl___simple_char/ops(20)
      integer   iter
      common/evl___term/iter
      real*8    t
      common/evl___term_real/t(20)
      character eofline
      integer   i
      eofline = char(13)
      ifac=0
      isim=0
      iexp=0
      iter=0
      pos=0
      err=0
      errpos=0
      reason=' '
      call upcase(formula,form)
      if (form(1:1).eq.'.') form='0'//form(1:len(form)-1)
      if (form(1:1).eq.'+') form=form(2:)
      do while (index(form,'**').gt.1)
        i=index(form,'**')
        form=form(1:i-1)//'^'//form(i+2:)
      enddo
      lf = length(form)
      call eval_nextch
      value=eval_expression()
      if (err.eq.0.and.ch.ne.eofline) then
        err=pos
        reason='unexpected characters'
      endif
      errpos=err
      reasonret=reason
      return
      end ! evaluate8
      subroutine exitfatal
      implicit none
      call exit(1)
      end
      subroutine exitnormal
      implicit none
      call exit(0)
      end
      subroutine FacVec(x,v,w)
      implicit none
      real    x
      real    v(3)
      real    w(3)
      integer i
      do i=1,3
        w(i) = x*v(i)
      enddo
      return
      end
      subroutine filescan(in,field,outfinal,lo)
      implicit none
      character in*(*)    !Input:  input filename
      character field*(*) !Input:
      character outfinal*(*)   !Output: result
      integer   lo        !Output: length of result
      integer   length
      integer   li
      character ufield*2  ! upcase first two chars of field
      integer   nodi      ! endposition of node
      integer   diri      ! endposition of directory
      integer   nami      ! endposition of name
      integer   typi      ! endposition of type
      integer   i
      character out*256
      out = ' '
      lo  = 0
      li = length(in)
      if(li.eq.0) goto 999
      nodi=index(in,':')
      diri = nodi
      do i=nodi+1,li
        if(in(i:i).eq.'/') diri = i
      enddo
      typi = li
      nami = li
      do i=li,diri+1,-1
        if(in(i:i).eq.'.') nami = i-1
      enddo
      call upcase(field(1:2),ufield)
      if(ufield.eq.'NO') then                    ! node
        lo = nodi
        if(lo.gt.0) out = in(1:nodi)
      else if(ufield.eq.'DE') then               ! device
      else if(ufield.eq.'RO') then               ! root
      else if(ufield.eq.'DI') then               ! directory
        lo = diri - nodi
        if(lo.gt.0) out = in(nodi+1:diri)
      else if(ufield.eq.'PA') then               ! path
        lo = diri
        if(lo.gt.0) out = in(1:lo)
      else if(ufield.eq.'NA') then               ! name
        lo = nami-diri
        if(lo.gt.0) out = in(diri+1:nami)
      else if(ufield.eq.'TY') then               ! type
        lo = typi-nami
        if(lo.gt.0) out = in(nami+1:typi)
      else if(ufield.eq.'FI') then               ! file
        lo = typi - diri
        if(lo.gt.0) out = in(diri+1:typi)
      else if(ufield.eq.'FU') then               ! fullfile
        lo = typi - diri
        if(lo.gt.0) out = in(diri+1:typi)
      else if(ufield.eq.'VE') then               ! version
      endif
999   continue
      outfinal = out
      return
      end ! filescan
      subroutine finish(nunit)
      implicit none
      integer   nunit
      character datetime*20
      character cputime*13
      character get_nodename*15
      character image*80
      integer   li
      call image_name(image,li)
      if (nunit.le.0) then
        call settime()
        if (nunit.lt.0) call str_3string_write(-nunit,image,
     1   get_nodename(),datetime(),'# started on # at #')
      else
        call str_3string_write(nunit,image,datetime(),cputime(),
     1   '# ended at # CPU time used #')
      endif
      return
      end ! finish
      subroutine GeneralRotMat(rotvec,phi,rotmat)
      implicit none
      real    rotvec(3)
      real    phi
      real    rotmat(3,3)
      integer normerror
      real    giro(3)
      real    sinphi
      real    cosphi
      real    f,g,h
      integer i
      integer j
      integer k
      call CopyVec(rotvec,giro)
      call NormVec(giro,giro,normerror)
      sinphi = sin(phi)
      cosphi = cos(phi)
      h = 1.0-cosphi
      do i=1,3
        rotmat(i,i) = giro(i)**2 * h + cosphi
        j = mod(i,3) + 1
        k = mod(j,3) + 1
        f = giro(j)*giro(k)*h
        g = giro(i)*sinphi
        rotmat(j,k) = f-g
        rotmat(k,j) = f+g
      enddo
      return
      end
      subroutine get___cputime(flag,value)
      implicit none
      integer flag
      integer value
      real    tarray(2)
      realetime
      value = nint(100.*etime(tarray))
      return
      end                       ! get___cputime
      subroutine get_commandline(nw)
      implicit none
      integer nw
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integeriargc
      character line(MaxPutBuffer)*(long)
      character word*(long)
      integer   l,lw
      integer   n
      integer   i
      l=0
      n=1
      line(n)=' '
      nw = iargc()
      call getarg(nw,word)
      if(length(word).eq.0) nw = nw - 1
      do i=1,nw
        call getarg(i,word)
        lw=length(word)
        if (l+lw.gt.len(word)-1) then
          n=n+1
          line(n)=' '
          if (n.gt.MaxPutBuffer) stop 'Too many arguments'
          l=0
        endif
        line(n)(l+2:)=word
        l=l+lw+1
      enddo
      do i=n,1,-1
        l=length(line(i))
        if(l.gt.0) call put_inp(line(i)(1:l))
      enddo
      return
      end ! get_commandline
      subroutine get_default_directory(string,ier)
      implicit none
      character string*(*)
      integer   ier
      integer   lenstr
      call mypwd(string,ier)
      if(ier.eq.0) string=string(1:lenstr(string))//'/'
      return
      end ! get_default_directory
      subroutine get_file(fullname,default,nd,result,ier)
      implicit none
      character fullname*(*)
      character default*(*)
      integer   nd
      character result*(*)
      integer   ier
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integer   lenstr
      integer   filectime
      integer   error
      character DefaultFile*(medium)
      integer   ld
      character d*(medium)
      character filename*(medium)
      character filetype*(medium)
      character line*(medium)
      integer   ll
      integer   lr
      character wild*(medium)
      character pre*(medium)
      integer   lpre
      character post*(medium)
      integer   lpost
      integer   i
      logical   GetInpDone
      logical   exist
      integer   maxctime
      integer   ctime
      wild = fullname
      call filescan(fullname,'NAME',filename,i)
      call str_remove(filename,'*',filename)
      call filescan(fullname,'TYPE',filetype,i)
      call str_remove(filetype,'*',filetype)
      i = index(fullname,'*')
      if(i.eq.1) then
        post = fullname(2:)
        lpost = length(post)
        pre = ' '
        lpre = 0
      else if(i.gt.1) then
        pre = fullname(1:i-1)
        lpre = i-1
        post = fullname(i+1:)
        lpost = length(post)
      else
        pre = ' '
        lpre = 0
        post = ' '
        lpost = 0
      endif
      if(lpost.gt.0) then
        if(index(post(1:lpost),'*').gt.0) then
          post = ' '
          lpost = 0
        endif
      endif
      GetInpDone = .false.
      DefaultFile = ' '
      if(nd.ne.0) then
        call get_inp(d,nd,' ',*999)
        GetInpDone = .true.
        if(d.eq.'.'.or.d.eq.'?') then
          defaultFile = ' '
          maxctime = 0
          call directorynosort(0,wild,line,error)
          do while(error.eq.0)
            ll = length(line)
            if(line(ll:ll).ne.'~') then
              ctime = filectime(line(1:ll))
              if(ctime.gt.maxctime) then
                call filescan(line,'FILE',DefaultFile,ld)
                maxctime = ctime
              endif
            endif
            call directorynosort(1,wild,line,error)
          enddo
          call directorynosort(-1,wild,line,error)
          if(lpre.ne.0) call str_remove(DefaultFile,pre,DefaultFile)
          if(lpost.ne.0) call str_remove(DefaultFile,post,DefaultFile)
          if(d.eq.'.') d = DefaultFile
        endif
      else ! i.e. nd.eq.0
        if(length(default).ne.0) then
          call build_file(default,filename,filetype,line,ld)
          inquire(file=line,exist=exist)
	  if(exist) then
            DefaultFile = line
          endif
	endif
        if(length(DefaultFile).eq.0) then
          maxctime = 0
          call directorynosort(0,wild,line,error)
          do while(error.eq.0)
            ll = length(line)
            if(line(ll:ll).ne.'~') then
              ctime = filectime(line(1:ll))
              if(ctime.gt.maxctime) then
                call filescan(line,'FILE',DefaultFile,ld)
                maxctime = ctime
              endif
            endif
            call directorynosort(1,wild,line,error)
          enddo
          call directorynosort(-1,wild,line,error)
	endif
        if(lpre.ne.0) call str_remove(DefaultFile,pre,DefaultFile)
        if(lpost.ne.0) call str_remove(DefaultFile,post,DefaultFile)
      endif
10    continue
      if(.not.GetInpDone) then
        call str_string(wild,'Enter # filename [#]',line)
        call str_string(DefaultFile,line,line)
        call get_inp_default(d,nd,line,*999)
      endif
      GetInpDone = .false.
      if(d.eq.'QUIT'.or.d.eq.'EXIT'.or.d.eq.'quit'.or.d.eq.'exit') then
        goto 999
      else if(d.eq.'?') then
        call str_unit(nout)
        call str_wrap(80)
        call str_string_out(wild,'Available # files:')
        call directory(0,wild,line,error)
        do while(error.eq.0)
          ll=length(line)
          if(line(ll:ll).ne.'~') then
            call filescan(line,'FILE',line,ll)
            if(lpre.ne.0) call str_remove(line,pre,line)
            if(lpost.ne.0) call str_remove(line,post,line)
            call str_out(line)
          endif
          call directory(1,wild,line,error)
        enddo
        call directory(-1,wild,line,error)
        call str_flush
        goto 10
      else
        if(lpre.gt.0) then
          if(d(1:lpre).ne.pre(1:lpre)) then
            ll = lenstr(d)
            call str_substitute(fullname,'*;',d(1:ll)//';',result)
          else
            call build_file(d,filename,filetype,result,lr)
          endif
        else
          call build_file(d,filename,filetype,result,lr)
        endif
      endif
      ier = 0
      return
999   ier = 1
      return
      end ! get_file
      subroutine get_grad(x,dd)
      implicit none
      real      x
      character dd*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      call get_real(x,dd)
      x = x/grad
      return
      end ! get_grad
      subroutine get_inp(d,nd,s,*)
      implicit none
      character d*(*)
      integer   nd
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integer   lenstr
      character datetime*20
      character today*11
      character rolex*10
      character cputime*13
      real      second
      external  second
      character dd*(long)
      integer   ndd
      character FileType*3
      real*8    value
      character reason*(medium)
      character local*(long)
      character local2*(long)
      character local3*(long)
      integer   L3
      logical   iftest
      logical   exist
      logical   expr
      integer   eof
      integer   ldd
      integer   ier
      integer   lft
      integer   idd
      integer   LL
      integer   i
      integer   n
      integer   ier2
      integer   n1,n2,n3,n4
      real      r
      logical   cmprs
      character oldpath*(long)
      character path*(long)
      integer   lpath
      character fm*1
      character varname*3
      logical   dovarpush
      logical   atfile
      integer   unit
      if (FirstTime) call get_inp_init(-5)
10    continue
      call get_inp_internal(dd,ndd,s,*900)
      if(dd(1:1).eq.'@'.or.dd(1:1).eq.'&') then
        atfile = dd(1:1).eq.'@'
        dd = dd(2:)
        ldd = lenstr(dd)
        call getenv(dd,local3)
        l3=length(local3)
        if (l3.gt.0) then
          dd=local3
          ldd=l3
        endif ! l3
        i = index(dd,'(')
        dovarpush = (i.gt.0)
        if(dovarpush) then
          if(dd(ldd:ldd).eq.')') ldd = ldd - 1
          local2 = dd(i:ldd)
          call str_collapse(dd(i+1:ldd),local2)
          call str_charsubstitute(local2,';',' ',local2)
          dd = dd(1:i-1)
          ldd = i-1
        endif
        call filemode(dd(1:ldd),fm)
        if(fm.ne.'-') then
          call image_name(FileType,lft)
          if(lft.ge.3) lft = 2
          FileType = FileType(1:lft)//'c'
          lft = lft + 1
          call build_file(dd(1:ldd),' ',FileType,dd,ldd)
          call filemode(dd(1:ldd),fm)
        endif
        if(fm.eq.'-') then
          call get_inp_stack(FlagPush,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) call str_write(nerr,
     +           'Get_inp: input file stack overflow')
            if(AbortOnError) call exitfatal
          else
            nrepeat = 0
            InputFileName = dd(1:ldd)
            call get_inp_open(dd(1:ldd),ninp,ier)
            if(ier.ne.0) then
              if(atfile) then
                if (nerr.gt.0) then
                  call get_message(ier,local,ier)
                  call str_write(nerr,local)
                endif
                if(AbortOnError) call exitfatal
              endif
              call get_inp_stack(FlagPop,ier)
            else
              if(dovarpush) then
                i = 0
                call str_header(local2,local3,local2)
                do while(length(local3).gt.0)
                  i = i + 1
                  call str_integer(i,'$#',varname)
                  call get_inp_add_alias(varname,local3)
                  call str_header(local2,local3,local2)
                enddo
              endif
              call get_newline
              if(nlog.gt.0) call str_integer_write(nlog,ninp,
     +             'Opened # '//dd(1:ldd))
              if(EchoStatus.eq.EchoAuto) nlog = nout
            endif
          endif
        else
          if(atfile) then
            if(nerr.gt.0) call str_string_write(nerr,dd,
     +           'Get_inp: file # does not exist')
            if(AbortOnError) call exitfatal
          endif
        endif
        goto 10
      else if(dd(1:max(1,lprefix)).eq.prefix.or.lprefix.eq.0) then
        dd = dd(lprefix+1:)
        ldd = lenstr(dd)
        call get_inp_find(dd,ldd,idd)   ! in upcase
        if(idd.lt.0) then
          d = dd
          nd = ndd
          return
        endif
        if(idd.eq.irepeat) then
          if(ndd.ge.2) then
            call get_inp_internal(dd,ndd,' ',*900)
            call get_integer(nrepeat,dd)
            if(nrepeat.le.0) then
              call get_newline
              nrepeat = 0
            else
              call get_restline(RepeatLine)
              call get_newline
            endif
            goto 10
          endif
        else if(idd.eq.iprefix) then
          if(ndd.eq.0) then
            prefix = ' '
            lprefix = 0
          else
            LocalUpcase = .false.
            call get_inp_internal(prefix,ndd,' ',*900)
            LocalUpcase = .true.
            lprefix = length(prefix)
          endif
        else if(idd.eq.iecho) then
          call get_inp_internal(dd,ndd,'ON/OFF/AUTO/DEBUG',*900)
          if(EchoStatus.ne.EchoDebug) then
            call upcase(dd,dd)
            if(dd.eq.'ON') then
              nlog = nout
              EchoStatus = EchoOn
            else if(dd.eq.'OFF') then
              nlog = 0
              EchoStatus = EchoOff
            else if(dd.eq.'AUTO') then
              EchoStatus = EchoAuto
            else if(dd.eq.'DEBUG') then
              nlog = nout
              EchoStatus = EchoDebug
            endif
          endif
        else if(idd.eq.ijournal) then
          call get_inp_internal(dd,ndd,'ON/OFF/SUSPEND',*900)
          call upcase(dd,dd)
          if(dd.eq.'ON') then
            if(.not.journalling.and.njournal.gt.0) then
              journalling = .true.    ! JOURNAL SUSPEND...JOURNAL ON
            else if(journalling) then ! JOURNAL ON ..... JOURNAL ON
              close(njournal)
              journalling = .false.
              njournal = 0
            endif
            if(njournal.eq.0) then
              call image_name(local,LL)
              call build_file(local,' ','.jrn',local,LL)
              call create_file(local(1:LL),njournal,local2,ier)
              if(ier.ne.0) then
                if(nerr.gt.0) call str_write(nerr,local2)
                if(AbortOnError) call exitfatal
              else
                journalling = .true.
              endif
            endif ! njournal
          else if(dd.eq.'OFF') then
            if (njournal.gt.0) then
              close(njournal)
              journalling = .false.
              njournal=0
            endif
          else if(dd.eq.'SUSPEND') then
            journalling = .false.
          endif
        else if(idd.eq.iALIAS) then
          if(ndd.eq.0) then
            if(nout.gt.0) then
              do i=1,NAlias
                call str_write(nout,AliasSource(i)//'=>'//
     +               AliasDestination(i))
              enddo
            endif
          else if(ndd.eq.1) then
            call get_inp_internal(dd,ndd,' ',*900)
            call get_inp_search_alias(dd,n)
            if(n.gt.0) then
              if(nout.gt.0) call str_write(nout,AliasSource(n)//'=>'//
     +             AliasDestination(n))
            else
              if(nerr.gt.0) call str_write(nerr,
     +             'Get_inp: alias not found')
            endif
          else
            call get_inp_internal(dd,ndd,' ',*900)
            call get_restline(local)
            call get_inp_add_alias(dd,local)
          endif
          call get_newline
          goto 10
        else if(idd.eq.IALL) then
          if(AllowAllDefault) then
            AllDefault = .true.
            d = ' '
            nd = 0
            return
          else
            if(nerr.gt.0) call str_string_write(nerr,prefix,
     +           '#ALL not allowed')
          endif
        else if(idd.eq.iUNALIAS) then
          if(ndd.eq.0) then
            continue
          else
            call get_inp_internal(dd,ndd,' ',*900)
            if(dd.eq.'*') then
              NAlias = 0
            else
              call get_inp_search_alias(dd,n)
              if(n.eq.0) then
                if(nerr.gt.0) call str_write(nerr,
     +               'Get_inp: alias not found')
                if(AbortOnError) call exitfatal
              else
                AliasSource(n) = AliasSource(NAlias)
                AliasDestination(n) = AliasDestination(NAlias)
                NAlias = NAlias - 1
              endif
            endif
          endif
        else if(idd.eq.iEVALUATE) then
          call get_restline(local)
          call upcase(local,local)
          call str_collapse(local,local)
          call evaluate8(local,value,ier,reason)
          if(ier.eq.0) then
            if(nout.gt.0) write (nout,*) value
            write (local,'(G23.16)') value
            call get_inp_add_alias('EVAL_RESULT',local)
          else
            if(nerr.gt.0) then
              call str_write_compress(.false.,cmprs)
              call str_write(nerr,local)
              call str_fill(local,ier,' ')
              local(ier:ier) = '^'
              call str_write(nerr,local(1:ier))
              call str_write_compress(cmprs,cmprs)
              call str_write(nerr,'Evaluate: '//reason)
              if(AbortOnError) call exitfatal
            endif
          endif
          call get_newline
          goto 10
        else if(idd.eq.iSTORE) then
          call get_inp_internal(dd,nd,'Var name',*900)
          call get_inp_search_alias('EVAL_RESULT',n)
          if(n.gt.0) then
            call get_inp_add_alias(dd,AliasDestination(n))
          else
            if(nerr.gt.0) call str_write(nerr,
     +           'Get_inp: nothing to store')
            if(AbortOnError) call exitfatal
          endif
        else if(idd.eq.iCOMMAND) then
          call image_file(local,ll)
          call Build_File_Type(local,' ','.commands',local,ll)
          call open_file(local,unit,local2,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) call str_write(nerr,local2)
            if(AbortOnError) call exitfatal
          else
            read(unit,100,iostat=ier) local
          endif
  100     format(a)
          do while(ier.eq.0)
            write(6,100) local(1:lenstr(local))
            read(unit,100,iostat=ier) local
          enddo
          close(unit)
        else if(idd.eq.iHELP) then
          call get_restline(dd)
          call image_help(dd,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
          call get_newline
        else if(idd.eq.iHELPL) then
          call get_restline(dd)
          call help('/mnt/schreurs/src/rtl/get_inp',dd,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
          call get_newline
        else if(idd.eq.iHELPG) then
          call get_restline(dd)
          call help('/mnt/schreurs/src/rtl/graphics',dd,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
          call get_newline
        else if(idd.eq.iDIRECTORY) then
          if (ndd.gt.0) then
            LocalUpcase = .false.
            call get_inp_internal(local,ndd,' ',*900)
            LocalUpcase = .true.
          else
            local = '*'
          endif
          ll = lenstr(local)
          call directory(0,local(1:LL),local2,ier)
          if(ier.ne.0.and.nerr.gt.0) then
            call get_message(ier,local,ier2)
            call str_write(nerr,local)
          endif
          n = 0
          if(nout.gt.0) then
            call str_unit(nout)
            oldpath = ' '
            do while(ier.eq.0)
              n = n + 1
              call filescan(local2,'path',path,lpath)
              if(path(1:lpath).ne.oldpath(1:lpath)) then
                call str_flush
                call str_out('Path='//path(1:lpath))
              endif
              oldpath = path
              call filescan(local2,'file',local3,l3)
              call str_out(local3)
              call directory(1,local(1:LL),local2,ier)
            enddo
            call str_flush
          endif ! nout.gt.0
          call directory(-1,local(1:LL),local2,ier)
          call str_integer(n,'#',local)
          call get_inp_add_alias('DIRCOUNT',local)
        else if(idd.eq.iEDIT) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'File name',*900)
          LocalUpcase = .true.
          call editor(dd,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
        else if(idd.eq.iEXIT) then
          goto 900
        else if(idd.eq.iGOTO) then
          call get_inp_internal(local,ndd,'label name',*900)
          call get_newline
          gotoactive = .true.
          local2 = ' '
          do while(local2(2:).ne.local)
            call get_inp_internal(local2,ndd,
     +           'goto active until !'//local,*900)
            call get_newline
          enddo
          gotoactive = .false.
          call get_newline
        else if(idd.eq.iCD) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'Directory specification',*900)
          LocalUpcase = .true.
          call set_default_directory(dd,PreviousDirectory,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
          if(nout.gt.0) call str_write(nout,'PreviousDirectory='//
     +         PreviousDirectory)
          if(nout.gt.0) then
            call get_default_directory(local,ier)
            if(ier.ne.0) then
              if(nerr.gt.0) then
                call get_message(ier,local,ier)
                call str_write(nerr,local)
              endif
              if(AbortOnError) call exitfatal
            else
              call str_write(nout,'Current directory='//local)
            endif
          endif
        else if(idd.eq.iBACK) then
          if(length(PreviousDirectory).gt.0) then
            call set_default_directory(PreviousDirectory,local,ier)
            if(ier.ne.0) then
              if(nerr.gt.0) then
                call get_message(ier,local,ier)
                call str_write(nerr,local)
              endif
              if(AbortOnError) call exitfatal
            else
              PreviousDirectory = local
            endif
          endif
          if(nout.gt.0) then
            call get_default_directory(local,ier)
            if(ier.ne.0) then
              if(nerr.gt.0) then
                call get_message(ier,local,ier)
                call str_write(nerr,local)
              endif
              if(AbortOnError) call exitfatal
            endif
            call str_write(nout,'Current directory='//local)
          endif
        else if(idd.eq.iIMPORT) then
          call get_inp_internal(dd,ndd,'Symbol name',*900)
          ldd = lenstr(dd)
          call get_symbol(dd(1:ldd),local)
          call get_inp_add_alias(dd(1:ldd),local)
        else if(idd.eq.iEXPORT) then
          call get_inp_internal(dd,ndd,'Alias name',*900)
          call get_inp_search_alias(dd,n)
          if(n.eq.0) then
            if(nerr.gt.0) call str_write(nerr,
     +           'Get_inp: alias not found')
          else
            ldd = lenstr(dd)
            ll = lenstr(AliasDestination(n))
            call set_symbol(dd(1:ldd),AliasDestination(n)(1:LL))
          endif
        else if(idd.eq.iMKDIR) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'Directory specification',*900)
          LocalUpcase = .true.
          call create_directory(dd,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
        else if(idd.eq.iSET_FILES) then
          call get_inp_internal(dd,ndd,'Input unit',*900)
          call get_integer(n1,dd)
          call get_inp_internal(dd,ndd,'Output unit',*900)
          call get_integer(n2,dd)
          call get_inp_internal(dd,ndd,'Error unit',*900)
          call get_integer(n3,dd)
          call get_inp_internal(dd,ndd,'LOG unit',*900)
          call get_integer(n4,dd)
          call set_files(n1,n2,n3,n4)
        else if(idd.eq.iSPAWN) then
          if(ndd.eq.0) then
            if(nerr.gt.0) then
              call str_write(nerr,'Get_inp: no command on line')
            endif
            if(AbortOnError) call exitfatal
          else
            call get_restline(local)
            call spawn(local,ier)
            call get_newline
            if(ier.ne.0) then
              if(nerr.gt.0) then
                call get_message(ier,local,ier)
                call str_write(nerr,local)
              endif
              if(AbortOnError) call exitfatal
            endif
          endif
        else if(idd.eq.iSTATUS) then
          if(nout.gt.0) then
            call image_name(local,LL)
            call str_string_write(nout,local,'Status of # at '//
     +           datetime())
            if(journalling) then
              call str_string_write(nout,local,
     +             'Journalling to file #.jrn')
            else
              if(njournal.gt.0) call str_string_write(nout,local,
     +             'Journalling to file #.jrn suspended')
            endif
            call get_default_directory(local,ier)
            call str_write(nout,'Current directory = '//local)
            inquire(unit=nout,name=local)
            call str_integer_write(nout,nout,'Output file # = '//local)
            if(nerr.gt.0) then
              inquire(unit=nerr,name=local)
            else
              local = 'Not in use'
            endif
            call str_integer_write(nout,nerr,'Error file # = '//local)
            if(nlog.gt.0) then
              inquire(unit=nlog,name=local)
            else
              local = 'Not in use'
            endif
            call str_integer_write(nout,nlog,'Log file # = '//local)
            call get_inp_stack(FlagStatus,ier)
            do i=1,PutbufferPointer
              call str_integer_write(nout,i,'Putbuf # :'//putbuffer(i))
            enddo
            call str_2integer_write(nout,WordCount,LineCount,
     +           'Word count = # Line count = #')
          endif
        else if(idd.eq.iVMS.or.idd.eq.iSHELL) then
          if(nout.gt.0) call str_write(nout,
     +      'Creating new process. Type control-D to return to program')
          call shell(ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
        else if(idd.eq.iRENAME) then
          LocalUpcase = .false.
          call get_inp_internal(local,ndd,'Old file name',*900)
          call get_inp_internal(local2,ndd,'New file name',*900)
          LocalUpcase = .true.
          call rename_file(local,local2,ier)
          if(ier.ne.0) then
            if(nerr.gt.0) then
              call get_message(ier,local,ier)
              call str_write(nerr,local)
            endif
            if(AbortOnError) call exitfatal
          endif
        else if(idd.eq.iTIME) then
          if(nout.gt.0) call str_write(nout,rolex())
        else if(idd.eq.iDATE) then
          if(nout.gt.0) call str_write(nout,today())
        else if(idd.eq.iSETCPU) then
          call settime
        else if(idd.eq.iCPU) then
          if(nout.gt.0) then
            local = cputime()
            call str_write(nout,local)
          endif
        else if(idd.eq.iSECOND) then
          if(nout.gt.0) call str_real_write(nout,second(),'#')
        else if(idd.eq.iSETEOF) then
          call get_inp_seteof
        else if(idd.eq.iWAIT) then
          call get_inp_internal(local,ndd,'nr of seconds',*900)
          call get_real(r,local)
          if(r.ge.0.0) then
            if(nout.gt.0) then
              call str_real_len_push(1)
              call str_real_out(r,'Waiting # seconds')
              call str_real_len_pop
            endif
            call mywait(r)
          endif
        else if(idd.eq.iPAUSE) then
          call get_mode(local)
          if(local(1:1).eq.'I') then
 11          call termline('Type GO to continue>',d,ier)
             call upcase(d,d)
             if (d.ne.'GO') goto 11
          endif
        else if(idd.eq.iWL) then
          if(nout.gt.0) call str_write(nout,char(27)//'[?3h')
        else if(idd.eq.iWN) then
          if(nout.gt.0) call str_write(nout,char(27)//'[?3l')
        else if(idd.eq.iIF) then
          LocalUpcase = .false.
          call get_inp_internal(local,ndd,'expression',*900)
          if(local.eq.'not') then
            expr = .false.
            call get_inp_internal(local,ndd,'expression',*900)
          else
            expr = .true.
          endif
          if(local.eq.'dir') then
            call get_inp_internal(local2,ndd,'directoryname',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            iftest = (fm.eq.'d')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'file') then
            call get_inp_internal(local2,ndd,'filename',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            iftest = (fm.eq.'-')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'filez') then
            call get_inp_internal(local2,ndd,'filename',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            if(fm.ne.'-') then
              call filemode(local2(1:ll)//'.Z',fm)
            endif
            inquire(file=local2(1:ll),exist=exist)
            iftest = (fm.eq.'-')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'eqs') then
            call get_inp_internal(local,ndd,'string1',*900)
            call get_inp_internal(local2,ndd,'string2',*900)
            iftest = (local.eq.local2)
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'alias') then
            call get_inp_internal(local,ndd,'alias name',*900)
            call get_inp_search_alias(local,n)
            iftest = (n.gt.0)
            if(.not.(iftest.eqv.expr)) call get_newline
          else
            if(nerr.gt.0) call str_string_write(nerr,local,
     +           'Get_inp: Unknown expression:#')
            if(AbortOnError) call exitfatal
            call get_newline
          endif
          LocalUpcase = .true.
        else if(idd.eq.iCLS) then
          if(nout.gt.0) call str_write(nout,
     +         char(27)//'[2J'//char(27)//'[0;0H')
        else if(idd.eq.iBELL) then
          if(nout.gt.0) call str_write(nout,char(7))
        else if(idd.eq.iSETPL) then
        else if(idd.eq.iSETPLR) then
        else if(idd.eq.iLISTPL) then
        else if(idd.eq.iOPTPL) then
        else if(idd.eq.iGETPL) then
        else if(idd.eq.iGETPLR) then
        else
          return  ! prefixed unknown command, can never be true
        endif
        call get_restline(col)
        istart = 1
        goto 10
      endif
      d = dd
      nd = ndd
      return
900   continue
      call get_inp_close(eof)
      if(eof.ne.0) goto 10  ! ignore this end of file
      return 1
      end ! get_inp
      subroutine get_inp_add_alias(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   n
      character usource*(long)
      if(NAlias.eq.MaxAlias) then
        if(nerr.gt.0) call str_integer_write(nerr,MaxAlias,
     +       'Get_inp: maximum aliases (#) exceeded')
        if(AbortOnError) call exitfatal
      else
        call upcase(source,usource)
        call get_inp_search_alias(usource,n)
        if(n.eq.0) then
          NAlias = NAlias + 1
          n = NAlias
        endif
        AliasSource(n) = usource
        AliasDestination(n) = destination
      endif
      return
      end ! get_inp_add_alias
      subroutine get_inp_close(eof)
      implicit  none
      integer   eof
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   ninp_old
      character local*(long)
      logical   LocalEof
      integer   ier
      ninp_old = ninp
      local = InputFileName
      LocalEof = noweof
      call get_inp_stack(FlagPop,ier)
      if(ier.eq.0) then
        call get_inp_close_internal(ninp_old)
        if(EchoStatus.eq.EchoAuto) nlog = 0
        if(nlog.gt.0) call str_integer_write(nlog,ninp_old,
     1   'Closed unit # '//local)
        if(LocalEof) then
          eof = 0   ! succes
        else
          eof = 1   ! ignore this end of file
        endif
      else
        eof = 0     ! succes
      endif
      return
      end ! get_inp_close
      subroutine get_inp_close_internal(unit)
      implicit none
      integer unit
      close(unit)
      return
      end ! get_inp_close_internal
      subroutine get_inp_default(d,nd,s,*)
      implicit none
      character d*(*)
      integer   nd
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integer   indexL
      integer   i1,i2
      if (FirstTime) call get_inp_init(-5)
      if(AllDefault) then
        d = ' '
      else
        EmptyLinesAllowed = .true.
        call get_inp(d,nd,s,*900)
        EmptyLinesAllowed = .false.
        if(d.eq.'*'.or.d.eq.'.') d = ' '
      endif
      if(length(d).eq.0) then
        i1 = index(s,'[')
        if(i1.gt.0) then
          i1 = i1 + 1
          i2 = index(s,']') ! is there a ]
          if(i2.ne.0) then
            i2 = indexL(s,']') ! yes, get last one
            i2 = i2 - 1
            if(i2.ge.i1) then
              if(DoUpcase) then
                call upcase(s(i1:i2),d)
              else
                d = s(i1:i2)
              endif
            endif
          endif
        endif
      endif
      return
900   continue
      EmptyLinesAllowed = .false.
      return 1
      end ! get_inp_default
      subroutine get_inp_find(dd,ldd,idd)
      implicit none
      character dd*(*)
      integer ldd
      integer idd
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   max_test
      parameter (max_test=11)
      character test(ntest)*(max_test)
      integer   ltest(ntest)
      save test,ltest
      integer nmatch
      integer i
      character udd*(long)
      data test(iALIAS) /'ALIAS'/ ltest(iALIAS) / 5/
      data test(iALL) /'ALL'/ ltest(iALL) / 3/
      data test(iATTACH) /'ATTACH'/ ltest(iATTACH) / 6/
      data test(iBACK) /'BACK'/ ltest(iBACK) / 4/
      data test(iBELL) /'BELL'/ ltest(iBELL) / 4/
      data test(iCD) /'CD'/ ltest(iCD) / 2/
      data test(iCLS) /'CLS'/ ltest(iCLS) / 3/
      data test(iCOMMAND) /'COMMAND'/ ltest(iCOMMAND) / 7/
      data test(iCPU) /'CPU'/ ltest(iCPU) / 3/
      data test(iDATE) /'DATE'/ ltest(iDATE) / 4/
      data test(iDEFINE_KEY) /'DEFINE_KEY'/ ltest(iDEFINE_KEY) /10/
      data test(iDIRECTORY) /'DIRECTORY'/ ltest(iDIRECTORY) / 9/
      data test(iECHO) /'ECHO'/ ltest(iECHO) / 4/
      data test(iEDIT) /'EDIT'/ ltest(iEDIT) / 4/
      data test(iEXIT) /'EXIT'/ ltest(iEXIT) / 4/
      data test(iEVALUATE) /'EVALUATE'/ ltest(iEVALUATE) / 8/
      data test(iEXPORT) /'EXPORT'/ ltest(iEXPORT) / 6/
      data test(iGETPL) /'GETPL'/ ltest(iGETPL) / 5/
      data test(iGETPLR) /'GETPLR'/ ltest(iGETPLR) / 6/
      data test(iGOTO) /'GOTO'/ ltest(iGOTO) / 4/
      data test(iHELP) /'HELP'/ ltest(iHELP) / 4/
      data test(iHELPG) /'HELPG'/ ltest(iHELPG) / 5/
      data test(iHELPL) /'HELPL'/ ltest(iHELPL) / 5/
      data test(iIF) /'IF'/ ltest(iIF) / 2/
      data test(iIMPORT) /'IMPORT'/ ltest(iIMPORT) / 6/
      data test(iJOURNAL) /'JOURNAL'/ ltest(iJOURNAL) / 7/
      data test(iLISTPL) /'LISTPL'/ ltest(iLISTPL) / 6/
      data test(iMKDIR) /'MKDIR'/ ltest(iMKDIR) / 5/
      data test(iOPTPL) /'OPTPL'/ ltest(iOPTPL) /5/
      data test(iPAUSE) /'PAUSE'/ ltest(iPAUSE) / 5/
      data test(iPREFIX) /'PREFIX'/ ltest(iPREFIX) / 6/
      data test(iRENAME) /'RENAME'/ ltest(iRENAME) / 6/
      data test(iREPEAT) /'REPEAT'/ ltest(iREPEAT) / 6/
      data test(iSECOND) /'SECOND'/ ltest(iSECOND) / 6/
      data test(iSETCPU) /'SETCPU'/ ltest(iSETCPU) / 6/
      data test(iSETEOF) /'SETEOF'/ ltest(iSETEOF) /6/
      data test(iSETPL) /'SETPL'/ ltest(iSETPL) / 5/
      data test(iSETPLR) /'SETPLR'/ ltest(iSETPLR) / 6/
      data test(iSET_FILES) /'SET_FILES'/ ltest(iSET_FILES) / 9/
      data test(iSHELL) /'SHELL'/ ltest(iSHELL) / 5/
      data test(iSPAWN) /'SPAWN'/ ltest(iSPAWN) / 5/
      data test(iSTATUS) /'STATUS'/ ltest(iSTATUS) / 6/
      data test(iSTORE) /'STORE'/ ltest(iSTORE) / 5/
      data test(iTIME) /'TIME'/ ltest(iTIME) / 4/
      data test(iUNALIAS) /'UNALIAS'/ ltest(iUNALIAS) / 7/
      data test(iVMS) /'VMS'/ ltest(iVMS) / 3/
      data test(iWAIT) /'WAIT'/ ltest(iWAIT) / 4/
      data test(iWL) /'WL'/ ltest(iWL) / 2/
      data test(iWN) /'WN'/ ltest(iWN) / 2/
      nmatch=0
      idd=-1
      if(ldd.gt.max_test) return
      call upcase(dd,udd)
      do i=1,ntest
        if (udd(1:ldd).eq.test(i)(1:ldd)) then
          idd=i
          if(ldd.eq.ltest(i)) return
          nmatch=nmatch+1
        endif
      enddo
      if (nmatch.gt.1) idd=-1
      return
      end ! get_inp_find
      subroutine get_inp_flush_all
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer eof
      if(.not.FirstTime) then
        do while (ninp.ne.5)
          call get_inp_close(eof)
        enddo
        call get_newline
        nrepeat=0
        putbufferpointer=0
      endif
      return
      end
      subroutine get_inp_init(flag)
      implicit none
      integer   flag
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   lenstr
      character local*(long)
      character InitFileName*(long)
      character get_nodename*15
      integer   ier
      character path*(long)
      integer   lpath
      character image*(medium)
      integer   li
      data FirstTime /.true./
      write(6,'(A)') ! xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
      FirstTime = .false.
      if(flag.ne.0) ninp = -5
      nout = 6
      nerr = 6
      nlog = 0
      seteof = .false.
      noweof = .false.
      DoUpcase = .true.
      AbortOnError = .false.
      LocalUpcase = .true.
      EmptyLinesAllowed = .false.
      AllowAlldefault = .false.
      AllDefault = .false.
      InitBusy = 0
      EchoStatus = EchoInit
      gotoactive = .false.
      prefix = '\\'
      lprefix = 1
      prompt = ' '
      lp = 2
      NAlias = 0
      journalling = .false.
      njournal = 0
      col = ' '
      istart = 1
      nrepeat = 0
      RepeatLine = ' '
      if(flag.ne.0) InputFileName = 'Unknown?'
      call config_path(path,lpath)
      call get_inp_add_alias('CONFIG_PATH',path(1:lpath))
      call image_name(image,li)
      call get_inp_add_alias('IMAGE_NAME',image(1:li))
      call str_2string(path,image,'##.init',initfilename)
      call get_username(local)
      call get_inp_add_alias('USER_NAME',local(1:lenstr(local)))
      call get_default_directory(local,ier)
      if(ier.eq.0) call get_inp_add_alias('WORK_DIR',
     +     local(1:lenstr(local)))
      local = get_nodename()
      call get_inp_add_alias('NODE_NAME',local)
      call get_mode(local)
      call get_inp_add_alias('PROCESS_MODE',local(1:lenstr(local)))
      call get_processname(local)
      call get_inp_add_alias('PROCESS_NAME',local(1:lenstr(local)))
      call get_inp_stack(FlagPush,ier)
      call getenv('GET_INP_INIT',InputFileName)
      call get_inp_open(InputFileName,ninp,ier)
      if(ier.ne.0) then
        call str_string(image,'#.init',InputFileName)
        call get_inp_open(InputFileName,ninp,ier)
        if(ier.ne.0) then
          call get_inp_stack(FlagPop,ier)
        else
          InitBusy = ninp
          call get_newline
        endif
      else
        InitBusy = ninp
        call get_newline
      endif
      call get_inp_stack(FlagPush,ier)
      InputFileName = InitFileName
      call get_inp_open(InputFileName,ninp,ier)
      if(ier.ne.0) then
        call get_inp_stack(FlagPop,ier)
      else
        if(InitBusy.eq.0) InitBusy = ninp
        call get_newline
      endif
      WordCount = 0
      LineCount = 0
      PutbufferPointer = 0
      call ccaction_push(1)
      call resetinterrupt
      return
      end ! get_inp_init
      subroutine get_inp_internal(dd,ndd,s, *)
      implicit none
      character dd*(*)
      integer   ndd
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integer   lenstr
      logical   InputFromKeyboard
      logical   OutputToScreen
      integer   status
      character c*1
      logical   SubstituteFlag
      integer   i1,i2,i3
      integer   lc
      integer   ls
      integer   ldd
      integer   idd
      logical   interrupted
      character temp*(long)
      integer   lt
      WordCount  = WordCount  + 1
      if(ninp.lt.0) then
        ninp = 5
        InputFileName = 'Keyboard'
        call get_newline
      endif
   10 continue
      if (interrupted()) then
        call resetinterrupt
      endif
      call get_inp_one_par(istart,i2)
      if(i2.gt.istart) then
        if(DoUpcase.and.LocalUpcase) then
          call Upcase(col(istart:i2),dd)
        else
          dd = col(istart:i2)
        endif
        istart = i2+1
        nitem = nitem - 1
        ndd = nitem
        return
      endif
30    continue
      if (interrupted()) then
        call resetinterrupt
      endif
      if(nrepeat.gt.0) then
        col = RepeatLine
        lc = length(col)
        if(nlog.ne.0)  call str_integer_write(nlog,nrepeat,
     +       '<repeat #> '//col)
      else if(PutbufferPointer.gt.0.and.InitBusy.eq.0) then
        col = putbuffer(PutbufferPointer)
        lc = length(col)
        if(nlog.ne.0)  call str_write(nlog,col)
        PutbufferPointer = PutbufferPointer - 1
      else
        if(ninp.eq.0) goto 70  ! eof if no input file specified
        LineCount = LineCount + 1
        ls = length(s)
        if(ls.eq.0) then
          if(prompt.eq.' ') then
             call image_name(prompt,lp)
             call upcase(prompt(1:1),c)
             call lowercase(prompt(2:),temp)
             prompt = c//temp(1:lp-1)//'>'
             lp = lp + 1
          endif
          temp = prompt
          lt = lp
        else
          temp = s
          lt = ls
        endif
        if(ninp.eq.5) then
          call ccaction_push(2)
   75     continue
          call str_flush
          if(lt+1.gt.80) then
            write(6,606) temp(1:lt)
            call cgetlin(' ',1,col,len(col),status)
          else
            call cgetlin(temp,lt+1,col,len(col),status)
          endif
          if (status.ne.0.and.status.ne.3) then
            write(6,607) 'PROMPT:',temp(1:lt)
            call flush(6)
            read (ninp,'(a)',iostat=status) col
            write(6,607) 'INPUT :',col(1:lenstr(col))
  607       format (a,1x,a)
            call flush(6)
          end if
          if (interrupted()) then
            call resetinterrupt
            goto 75
          endif
          call resetinterrupt
          call ccaction_pop()
        else
          read(ninp,'(a)',iostat=status) col
        endif
        lc = length(col)
        if(status.ne.0) then
          goto 70
        endif
        call str_charsubstitute(col,char(9),' ',col)
        if(journalling) then
          if(col(1:1).eq.'@'.or.col(1:1).eq.'&') then
            write (njournal,605) col(1:max(1,lc))
605         format('!',a)
          else
            write (njournal,606) col(1:max(1,lc))
606         format(a)
          endif
        endif
        if(nlog.ne.0)  call str_write(nlog,col)
      endif ! nrepeat
      if(lc.eq.0.and.EmptyLinesAllowed) then
        dd = ' '
        ndd = 0
        nitem = 0
        call get_newline
        return
      endif
      if(lc.eq.0) goto 30
      if(col(1:1).eq.'!') then
        if(gotoactive) then
          continue
        else
          goto 30
        endif
      endif
      istart = 1
      do while(col(istart:istart).eq.' ')
        istart = istart + 1
      enddo
      if(istart.gt.1) then
        col = col(istart:)
        istart = 1
      endif
      i1 = istart
      call get_inp_one_par(i1,i2)
      i2 = i2 - 1
      if(i2.ge.i1) then
        SubstituteFlag=.true.
        call get_inp_substitute(i1,i2,SubstituteFlag)
        call get_inp_one_par(i1,i3)
        i3 = i3 - 1
        call upcase(col(i1:i3),dd)
        if((dd(1:max(1,lprefix)).eq.prefix).or.(lprefix.eq.0)) then
          ldd = i3-i1+1-lprefix
          call get_inp_find(dd(lprefix+1:),ldd,idd)    !  dd in upcase
          if(idd.eq.ialias.or.idd.eq.iunalias.or.idd.eq.istore.or.
     +         idd.eq.iexport.or.idd.eq.iimport) then
            SubstituteFlag=.false.
          else if(idd.eq.irepeat) then
            i1 = i2 + 1
            call get_inp_one_par(i1,i2)
            i2 = i2 - 1
            if (i2.ge.i1) then
              call get_inp_substitute(i1,i2,SubstituteFlag)
            endif
            goto 100
          endif
        endif
        i1 = i2 + 1
        call get_inp_one_par(i1,i2)
        i2 = i2 - 1
        do while(i2.ge.i1)
          call get_inp_substitute(i1,i2,SubstituteFlag)
          i1 = i2 + 1
          call get_inp_one_par(i1,i2)
          i2 = i2 - 1
        enddo
      endif
100   continue
      if(nrepeat.gt.0) then
        call get_inp_nrep
        nrepeat = nrepeat - 1
      endif
      call str_word_count(col(istart:),nitem)
      goto 10
70    continue
      if(InitBusy.eq.ninp) then
        InitBusy = 0
        if(EchoStatus.eq.EchoInit) then
          if(.not.OutputToScreen().and.InputFromKeyboard()) then
            EchoStatus = EchoOn
            nlog = nout
          else
            EchoStatus = EchoAuto
          endif
        endif
      endif
      return 1
      end ! get_inp_internal
      subroutine get_inp_nrep
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   length
      integer   n
      integer   ld
      character result*12
      character form*80
      integer   i
      call get_inp_search_alias('NREP',n)
      if(n.gt.0) then
        ld = length(AliasDestination(n))
        call get_integer(i,AliasDestination(n))
        i = i + 1
        call str_integer(i,'#',result)
        if(AliasDestination(n)(1:1).eq.'0') then
          if(length(result).lt.ld) then
            call str_2integer(ld,ld,'(I#.#)',form)
            write(result,form) i
          endif
        endif
        AliasDestination(n) = result
      endif
      return
      end ! get_inp_nrep
      subroutine get_inp_one_par(i1,i2)
      implicit none
      integer i1,i2
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if(i1.ge.len(col)) then
        i2 = i1
        return
      endif
      do while((col(i1:i1).eq.' '.or.col(i1:i1).eq.',').and.
     +     i1.lt.len(col))
        i1 = i1 + 1
      enddo
      i2 = i1
      if(i1.eq.len(col)) return
      do while(col(i2:i2).ne.' '.and.col(i2:i2).ne.','.and.
     +     i2.lt.len(col))
        i2 = i2 + 1
      enddo
      return
      end ! get_inp_one_par
      subroutine get_inp_open(name,unit,ier)
      implicit none
      character name*(*)
      integer   unit
      integer   ier
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   lenstr
      integer   length
      character local*(long),local2*(long)
      integer   ll,l2
      integer   status
      integer   local_unit
      integer   ln
      ln = lenstr(name)
      local_unit = unit
      call get_lun(unit,ier)
      if (ier.ne.0) then
        status=ier
      else
        local=name
        ll=ln
        call getenv(local(1:ll),local2)
        l2 = length(local2)
        if (l2.gt.0) then
          local=local2
          ll=l2
        endif
        open(unit=unit,file=local(1:ll),status='old',iostat=status)
      endif
      if(status.ne.0) then
        ier = status
      else
        if(InitBusy.eq.0.and.local_unit.gt.0) noweof=seteof
        ier = 0
      endif
      if(InitBusy.eq.0.and.local_unit.gt.0) seteof=.false.
      return
      end ! get_inp_open
      subroutine get_inp_search_alias(string,n)
      implicit none
      character string*(*)
      integer   n
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   i
      character ustring*(long)
      call upcase(string,ustring)
      do i=1,NAlias
        if(ustring.eq.AliasSource(i)) then
          n = i
          return
        endif
      enddo
      n = 0
      return
      end ! get_inp_search_alias
      subroutine get_inp_seteof
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if (FirstTime) call get_inp_init(-5)
      seteof = .true.
      return
      end ! get_inp_seteof
      subroutine get_inp_stack(flag,ier)
      implicit none
      integer   flag
      integer   ier
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   lenstr
      integer   MaxStack
      parameter (MaxStack=20)
      logical   debug
      parameter (debug=.false.)
      integer   sp
      integer   FileStack(MaxStack)
      character ColStack(MaxStack)*(long)
      integer   IstartStack(MaxStack)
      character RepeatLineStack(MaxStack)*(long)
      integer   NRepeatStack(MaxStack)
      character FileNameStack(MaxStack)*(long)
      logical   EofStack(MaxStack)
      save sp,FileStack,ColStack,IstartStack,RepeatLineStack,
     +     NRepeatStack,FileNameStack,EofStack
      integer   i,j
      integer   LL
      integer   DummyUnit
      character local*(long)
      logical   cmprs
      character varname*10
      data sp /0/
      if(flag.eq.FlagClear) then
        sp=0
      else if(flag.eq.FlagPush) then
        if(sp.ge.MaxStack) then
          ier = 1
          return
        endif
        call get_lun(DummyUnit,ier) ! check if we can open a new file
        if(ier.ne.0) return
        sp = sp + 1
        EofStack(sp)          = noweof
        FileStack(sp)         = ninp
        ColStack(sp)          = col
        IstartStack(sp)       = istart
        NRepeatStack(sp)      = nrepeat
        RepeatLineStack(sp)  = RepeatLine
        FileNameStack(sp)    = InputFileName
        if(debug) call str_out('pushing aliases')
        i = 1
        call str_integer(i,'$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          call str_2integer(sp,i,'#$#',varname)
          AliasSource(j) = varname
          if(debug) call str_out(varname)
          i = i + 1
          call str_integer(i,'$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug) call str_flush
      else if(flag.eq.FlagPop) then
        if(sp.le.0) then
          ier = 1
          return
        endif
        noweof      = EofStack(sp)
        ninp        = FileStack(sp)
        col         = ColStack(sp)
        istart      = IstartStack(sp)
        nrepeat     = NRepeatStack(sp)
        RepeatLine = RepeatLineStack(sp)
        InputFileName = FileNameStack(sp)
        i = 1
        if(debug)call str_out('removing aliases')
        call str_integer(i,'$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          if(debug)call str_out(varname)
          AliasSource(j) = AliasSource(NAlias)
          AliasDestination(j) = AliasDestination(NAlias)
          NAlias = NAlias - 1
          i = i + 1
          call str_integer(i,'$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug)call str_flush
        i = 1
        if(debug) call str_out('popping aliases')
        call str_2integer(sp,i,'#$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          if(debug) call str_out(varname)
          call str_integer(i,'$#',varname)
          AliasSource(j) = varname
          i = i + 1
          call str_2integer(sp,i,'#$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug) call str_flush
        sp = sp - 1
      else if(flag.eq.FlagStatus) then
        call str_unit(nout)
	call str_integer_write(nout,sp,'Stack size=#')
        do i=1,sp
          call str_integer_out(i,'File #')
          call str_integer_out(FileStack(i),'#')
          call str_out(FileNameStack(i))
          call str_logical_out(EofStack(i),'Eof=#')
          call str_flush
          if(IstartStack(i).eq.len(col)+1) then
            call str_write(nout,'Positioned at beginning of file')
          else
            call str_write(nout,'not at beginning of file')
            LL = lenstr(ColStack(i))
            j = IstartStack(i)
            call str_write_compress(.false.,cmprs)
            call str_write(nout,'command:'//ColStack(i)(1:LL))
	    if(j.le.len(local)) then
              call str_fill(local,j,' ')
              local(j:j) = '^'
              call str_write(nout,'pointer:'//local(1:j))
	    endif
            call str_write_compress(cmprs,cmprs)
          endif
          if(NRepeatStack(i).gt.0) then
            call str_integer_write(nout,NRepeatStack(i),
     +           'Repeat #:'//RepeatLineStack(i))
          endif
        enddo
        call str_integer_out(0,'File #')
        call str_integer_out(ninp,'#')
        call str_out(InputFileName)
        call str_logical_out(noweof,'Eof=#')
        call str_flush
        LL = lenstr(col)
        j = istart
        call str_write_compress(.false.,cmprs)
        call str_write(nout,'command:'//col(1:LL))
        if(j.le.len(local)) then
          call str_fill(local,j,' ')
          local(j:j) = '^'
          call str_write(nout,'pointer:'//local(1:j))
	endif
        call str_write_compress(cmprs,cmprs)
        if(nrepeat.gt.0) then
          call str_integer_write(nout,nrepeat,'Repeat #:'//RepeatLine)
        endif
        call str_logical_write(nout,seteof,'EOF flag for next file = #')
      endif
      ier = 0
      return
      end ! get_inp_stack
      subroutine get_inp_substitute(i1,i2,dowhole)
      implicit none
      integer   i1
      integer   i2
      logical   dowhole
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      integer   lenstr
      integer   n1
      integer   n2
      character word*(long)
      integer   lw
      integer   n
      integer   ln
      character OldWord*(long)
      character NewWord*(long)
      word = col(i1:i2)
      call upcase(word,OldWord)
      lw = i2-i1+1
      n1 = index(word,'''')
      if(n1.eq.0) then
        if(dowhole) then
          call get_inp_search_alias(word,n)
          if(n.gt.0) then
            ln = lenstr(AliasDestination(n))
            word = AliasDestination(n)(1:ln)
            lw = ln
          endif ! n > 0
        endif
      else
        do while(n1.gt.0)
          n2 = index(word(n1+1:),'''')
          if(n2.eq.0) then
            if(n1.gt.1) then
              word = word(1:n1-1)//word(n1+1:)   ! ab'cd
            else
              word = word(2:)                    ! 'ab       ! ' extra quote
            endif
            lw = lw - 1
            n2 = lw
          else if(n2.eq.1) then
            if(n1.gt.1) then
              word = word(1:n1)//word(n1+2:)     ! ab''cd
            else
              word = word(2:)                    ! ''abc
            endif
            lw = lw - 1
            n2 = n1
            n1 = n2 + 1     ! disable substitution
          else ! n2 > 1
            n2 = n1 + n2
            if(n1.gt.1) then
              word = word(1:n1-1)//word(n1+1:n2-1)//word(n2+1:) ! ab'c'd
            else
              word = word(2:n2-1)//word(n2+1:)                  ! 'cd'e
            endif
            lw = lw - 2
            n2 = n2 - 2
          endif ! n2
          if(n1.le.n2) then
            call get_inp_search_alias(word(n1:n2),n)
            if(n.gt.0) then
              ln = lenstr(AliasDestination(n))
              if(n1.gt.1) then
                word = word(1:n1-1)//AliasDestination(n)(1:ln)//
     +               word(n2+1:)
              else
                word = AliasDestination(n)(1:ln)//word(n2+1:)
              endif
              lw = lw - (n2-n1+1) + ln
              n2 = n1 + ln - 1
            endif ! n > 0
          endif ! n1 < n2
          n1 = index(word(n2+1:),'''')
          if (n1.gt.0) n1 = n1 + n2
        enddo
      endif
      call upcase(word,NewWord)
      if(NewWord.eq.OldWord) then
        continue
      else
        if(i1.gt.1) then
          col = col(1:i1-1)//word(1:lw)//col(i2+1:)
        else
          col = word(1:lw)//col(i2+1:)
        endif
        i2 = i1 + lw - 1
      endif
      return
      end ! get_inp_substitute
      subroutine get_inp_upcase(b)
      implicit none
      character b*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      character onoff*3
      if (FirstTime) call get_inp_init(-5)
      call upcase(b,ONOFF)
      DoUpcase = (ONOFF.eq.'ON')
      return
      end ! get_inp_upcase
      subroutine get_integer(ix,dd)
      implicit none
      integer   ix
      character dd*(*)
      real      r
      call get_real(r,dd)
      ix = nint(r)
      return
      end ! get_integer
      subroutine get_logical(s1,s2)
      implicit none
      character s1*(*)
      character s2*(*)
      integer   lenstr
      character s3*256
      call upcase(s1,s3)
      call getenv(s3(1:lenstr(s3)),s2)
      return
      end ! get_logical
      subroutine get_lun(unit,ier)
      implicit none
      integer unit                        ! returned unit number
      integer ier                         ! 0=ok, <>0 = no free unit available
      integer max_lun
      parameter (max_lun=99)
      integer i
      logical opened
      do i=max_lun,1,-1
        inquire(unit=i,opened=opened)
        if(.not.opened) then
          unit = i
          ier  = 0
          return
        endif
      enddo
      ier = 1
      unit = 0
      return
      end ! get_lun
      subroutine get_message(nr,string,ier)
      implicit none
      integer   nr
      character string*(*)
      integer   ier
      call str_integer(nr,'Message error number = #',string)
      ier=0
      return
      end ! get_message
      subroutine get_mode(c)
      implicit none
      character c*(*)
      logical InputFromKeyboard
      character lastmode*11
      save lastmode
      data lastmode /'unknown'/
      if(lastmode.eq.'unknown') then
        if(inputFromKeyboard()) then
          lastmode = 'INTERACTIVE'
        else
          lastmode = 'OTHER'
        endif
      endif
      call CopyStr(lastmode,c)
      return
      end ! get_mode
      subroutine get_newline
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if (FirstTime) call get_inp_init(-5)
      istart = len(col) + 1
      return
      end ! get_newline
      character*15 function get_nodename()
      implicit none
      integermygethostname
      integer lenstr
      character*100 s
      integer ier
      integer ls
      ier = mygethostname(s,len(s))
      if (ier.ne.0) then
        get_nodename='HostNameError'
      else
        ls = index(s,'.') - 1
        if(ls.eq.-1) ls = lenstr(s)
        get_nodename=s(1:ls)
      endif
      return
      end ! get_nodename
      subroutine get_processname(value)
      implicit none
      character value*(*)
      integergetpid
      character s*5
      write(s,'(i5.5)') getpid()
      value=s
      return
      end ! get_processname
      subroutine get_real(x,dd)
      implicit none
      real      x
      character dd*(*)
      integer   iostat
      read(dd,*,iostat=iostat) x
      if (iostat.ne.0) x = 0.0
      return
      end ! get_real
      subroutine get_restline(l)
      implicit none
      character l*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if (FirstTime) call get_inp_init(-5)
      if(istart.lt.len(col)) then
        l = col(istart:)
      else
        l = ' '
      endif
      return
      end ! get_restline
      integer function get_str_unit()
      implicit none
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      get_str_unit=unit
      return
      end ! get_str_unit
      subroutine get_symbol(symbol,value)
      implicit none
      character symbol*(*)
      character value*(*)
      integer   lenstr
      call getenv(symbol(1:lenstr(symbol)),value)
      return
      end ! get_symbol
      subroutine get_term_size(x,y)
      implicit none
      integer x
      integer y
      call termsz(x,y)
      if(x.eq.0.or.y.eq.0) then
        x = 80
        y = 24
      endif
      return
      end
      subroutine get_username(name)
      implicit none
      character name*(*)
      call getlog(name)
      return
      end ! get_username
      subroutine getmat(v,n,u)
      implicit none
      real    v(3,3,*)          ! Input: array of matrices
      integer n                 ! Input: element nr
      real    u(3,3)            ! Output
      integer i
      integer j
      do j=1,3
        do i=1,3
          u(i,j) = v(i,j,n)
        enddo
      enddo
      return
      end
      subroutine getpar(n,text,error)
      implicit none
      integer   n
      character text*(*)
      integer   error
      integeriargc
      error = 0
      if (iargc().lt.n) error=1
      if (error.eq.0) then
        call getarg(n,text)
      else
        text = ' '
      endif
      return
      end ! getpar
      subroutine GetVec(s,n,v)
      implicit none
      real    s(3,*)
      integer n
      real    v(3)
      integer i
      do i=1,3
        v(i) = s(i,n)
      enddo
      return
      end
      subroutine GetVecI(s,n,v)
      implicit none
      integer s(3,*)
      integer n
      integer v(3)
      integer i
      do i=1,3
        v(i) = s(i,n)
      enddo
      return
      end
      subroutine help(library,key,ier)
      implicit none
      character library*(*)
      character key*(*)
      integer   ier
      integer   maxitem
      parameter (maxitem=500)
      logical   debug
      parameter (debug=.false.)
      integer   lenstr
      integer   length
      character filename*256
      integer   lf
      integer   unit
      integer   ni
      integer   nl
      character line*256
      character item(maxitem)*20
      integer   li
      character lcitem(maxitem)*20
      integer   level(maxitem)
      integer   start(maxitem)
      integer   stop(maxitem)
      integer   i
      integer   LL
      integer   iostat
      integer   currentlevel
      integer   nextlevel
      integer   pointer
      integer   k1,k2
      character answer*80
      integer   la
      character lclkey*80
      logical   display
      integer   pagex,pagey
      character message*256
      integer   iy
      lclkey = key
      call build_file(library,'help','.hlp',filename,lf)
      call open_file(filename(1:lf),unit,message,ier)
      if(ier.ne.0) then
        call str_write(6,message)
        return
      endif
      call get_term_size(pagex,pagey)
      if(pagex.gt.len(line)) pagex = len(line)
      ni = 1
      nl = 0
      start(ni) = 0
      stop(ni) =  0
      level(ni) = 0
      call filescan(filename,'NAME',item(ni),li)
      read(unit,100,iostat=iostat) line
 100  format(a)
      do while(iostat.eq.0)
        nl = nl + 1
        if(line(1:1).ge.'1'.and.line(1:1).le.'9'.and.
     1   line(2:2).eq.' ') then
          if(ni.lt.maxitem) then
            ni = ni + 1
          else
            call str_write(6,'Too many items in help')
          endif
          start(ni) = 0
          stop(ni) = 0
          call str_leading(line(2:),item(ni))
          call lowercase(item(ni),lcitem(ni))
          level(ni) = ichar(line(1:1))-48
        else
          if(start(ni).eq.0) start(ni) = nl
          stop(ni) = stop(ni) + 1
        endif
        read(unit,100,iostat=iostat) line
      enddo
      if(debug) call str_num_write(6,ni,'# item^')
      currentlevel = 0
      pointer = 1
 10   continue
      display = (length(lclkey).eq.0)
      if(.not.display) then
        call str_header(lclkey,answer,lclkey)
      else
        if(debug) call str_integer_write(6,currentlevel,'currentlevel=')
        if (currentlevel.lt.0) goto 900
        rewind unit
        do i=1,start(pointer)-1
          read(unit,100)
        enddo
        iy = 0
        do i=1,stop(pointer)
          read(unit,100) line
          write(6,100) line(1:lenstr(line))
          iy = iy + 1
          if(iy.gt.pagey) then
            call termline('Type return',answer,ier)
            iy = 0
          endif
        enddo
      endif
      nextlevel = currentlevel + 1
      i = pointer+1
      k1 = 0
      k2 = 0
      line = ' '
      LL = 1
      do while(i.le.ni)
        if(level(i).eq.nextlevel) then
          if(k1.eq.0) then
            if(display) call str_write(6,'Information available on:')
            k1 = i
          endif
          k2 = i
          li = length(item(i))
          if(LL+li.ge.pagex) then
            if(display) write(6,100) line(1:Lenstr(line))
            line = ' '
            LL = 1
          endif
          line = line(1:LL)//item(i)
          LL = LL + 10*(1+(li/10))
        else if(level(i).lt.nextlevel) then
          i = ni
        endif
        i = i + 1
      enddo
      if(display) then
        if(LL.gt.1) write(6,100) line(1:Lenstr(line))
        if(currentlevel.eq.0) then
          line = 'Topic?'
        else if(k1.eq.0) then
          line = 'type return'
        else
          li = lenstr(item(pointer))
          line = item(pointer)(1:li)//' Subtopic?'
        endif
        ll = lenstr(line)
        if(debug) call str_write(6,'before termline:'//line(1:ll))
        call termline(line(1:ll),answer,ier)
        if(debug) call str_integer_write(6,ier,'error after termline=#')
        if(ier.ne.0) then
          call str_write(6,' ')
          goto 900
        endif
      endif
      la = length(answer)
      call lowercase(answer,answer)
      if(la.eq.0) then
        currentlevel = currentlevel - 1
        k1 = pointer
        do i=1,k1
          if(level(i).eq.currentlevel) pointer = i
        enddo
        goto 10
      else if(k1.eq.0) then
        if(answer(1:1).eq.'q') then
          goto 900
        endif
        currentlevel = currentlevel - 1
        k1 = pointer
        do i=1,k1
          if(level(i).eq.currentlevel) pointer = i
        enddo
        goto 10
      else
        do i=k1,k2
          if(level(i).eq.nextlevel) then
            if(answer(1:la).eq.lcitem(i)(1:la)) then
              pointer = i
              currentlevel = nextlevel
              goto 10
            endif
          endif
        enddo
        if(answer(1:1).eq.'q') then
          goto 900
        endif
        call str_write(6,answer//' not found')
        if(display) then
          lclkey = ' '
          currentlevel = 0
        endif
        goto 10
      endif
 900  continue
      close(unit)
      ier = 0
      return
      end ! help
      subroutine image_file(name,ln)
      implicit none
      character name*(*)
      integer   ln
      integer   lenstr
      integer   ier
      call getpar(0,name,ier)
      ln = lenstr(name)
      return
      end ! image_file
      subroutine image_help(text,ier)
      implicit none
      character text*(*)
      integer   ier
      character fm*1
      integer   length
      character name*132
      integer   lp
      character path*132
      integer   ln
      character fullname*132
      logical   exist
      character uname*132
      integer   lf
      call image_name(name,ln)
      call upcase(name,uname)
      call getenv(uname,fullname)
      if(length(fullname).gt.0) then
        inquire(file=fullname,exist=exist)
        if(exist) then
          call netscape(fullname,ier)
          return
        endif
      endif
      call config_path(path,lp)
      call str_2string(path,name,'#/#.html',fullname)
      inquire(file=fullname,exist=exist)
      if(exist) then
        call netscape(fullname,ier)
        return
      endif
      call str_string(path,'#html',fullname)
      lf = length(fullname)
      call filemode(fullname(1:lf),fm)
      if(fm.ne.'d') then
        call str_string(path,'#doc',fullname)
        lf = length(fullname)
        call filemode(fullname(1:lf),fm)
      endif
      if(fm.eq.'d') then
        path = fullname
        if(length(text).eq.0) then
          call str_string(path,'#/index.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call netscape(fullname,ier)
            return
          endif
          call str_2string(path,name,'#/#.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call netscape(fullname,ier)
            return
          endif
          call str_2string(path,name,'#/#.hlp',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call help(fullname,text,ier)
            return
          endif
        else
          call str_string(path,'#/commands.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call str_concat(fullname,'#',fullname)
            call str_concat(fullname,text,fullname)
            call netscape(fullname,ier)
            return
          endif
          call str_2string(path,name,'#/#_commands.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call str_concat(fullname,'#',fullname)
            call str_concat(fullname,text,fullname)
            call netscape(fullname,ier)
            return
          endif
          call str_2string(path,name,'#/#.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call str_concat(fullname,'#',fullname)
            call str_concat(fullname,text,fullname)
            call netscape(fullname,ier)
            return
          endif
          call str_2string(path,name,'#/#.hlp',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) then
            call help(fullname,text,ier)
            return
          endif
        endif
      else
        call str_2string(path,name,'##.hlp',fullname)
        inquire(file=fullname,exist=exist)
        if(exist) then
          call help(fullname,text,ier)
          return
        endif
      endif
      ier = 1
      return
      end ! image_help
      subroutine image_name(name,ln)
      implicit none
      character name*(*)
      integer   ln
      character s*80
      integer   ls
      call image_file(s,ls)
      call filescan(s(1:ls),'NAME',name,ln)
      return
      end ! image_name
      subroutine image_path(name,ln)
      implicit none
      character name*(*)
      integer   ln
      integer   lenstr
      character s*80
      integer   ls
      integer   ier
      call image_file(s,ls)
      call filescan(s(1:ls),'PATH',name,ln)
      if(ln.eq.0) then
        call get_default_directory(name,ier)
        ln = lenstr(name)
      else if(name(1:ln).eq.'./') then
        call get_default_directory(name,ier)
        ln = lenstr(name)
      endif
      return
      end ! image_path
      integer function indexL(s,c)
      character s*(*)
      character c*(*)
      integer lc,ls
      integer i,n
      lc = len(c)
      ls = len(s)
      do i=ls-lc+1,1,-1
        if(s(i:i+lc-1).eq.c(1:lc)) then
          n = i
          goto 20
        endif
      enddo
      n = ls
20    continue
      indexl = n
      return
      end ! indexL
      logical function InputFromKeyboard()
      implicit none
      integer   lastmode
      save lastmode
      data lastmode /-1/
      if(lastmode.eq.-1) then
        call myinputmode(lastmode)
      endif
      InputFromKeyboard= (lastmode.eq.1)
      return
      end !  InputFromKeyboard()
      logical function interrupted()
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      logical debug
      parameter (debug=.false.)
      logical   str_equal
      integer   length
      integer   getcc
      character datetime*20
      integer   count
      integer   ier
      character col*80
      character c*1
      character myprog*80
      integer   lm
      character prompt*80
      if (action.eq.0) then
        if(debug) write(77,*) datetime(),' DBG action=0'
        interrupted=.false.
        return
      endif
      count=getcc()
      if(debug) write (77,*) datetime(),' DBG> count=',count,
     +     'self=',selfinterrupt,' action=',action
      if (count+selfinterrupt.eq.0) then
        interrupted=.false.
        return
      endif
      if (action.eq.0) then
        if(debug)write(77,*) datetime(),' DBG> Interrupt ignored'
        interrupted=.false.
      else if (action.eq.1) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted, back to command line'
        call get_inp_flush_all
        interrupted=.true.
      else if (action.eq.2) then
        if(debug) write(77,*) datetime(),' DBG> Interrupted action 2'
        call get_mode(c)
        if(c.eq.'I') then
          if(debug) write(77,*) datetime(),' INTERACIVE'
          call image_name(myprog,lm)
          call str_string(myprog,'Do you want to terminate # [y]?',
     +         prompt)
          call termline(prompt(1:length(prompt)),col,ier)
          if (ier.ne.0) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal ier'
            call exitfatal
          else if (length(col).eq.0) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal length'
            call exitfatal
          else if (str_equal(col,'y')) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal yes'
            call exitfatal
          endif
        else
          if(debug) write(77,*) datetime(),' non INTERACIVE'
        endif
        interrupted=.true.
        action = 3
      else if (action.eq.3) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted exitfatal at action 3'
        call exitfatal
        interrupted=.false.
      else if (action.eq.4) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted core dump at action 4'
        call abort
        interrupted=.false.
      else
        if(debug) write(77,*) datetime(),
     +       'DBG> Interrupted, illegal interrupt action'
        interrupted=.true.
      end if
      return
      end
      subroutine InvertMat(u,v,ier)
      implicit none
      real    u(3,3) ! source matrix
      real    v(3,3) ! result
      integer ier
      real MatVol
      real x(3,3) ! temp result
      real volu
      volu = MatVol(u)
      if(abs(volu).lt.1.0e-10) then
        ier = 1
        call unit_matrix(v)
      else
        ier = 0
        x(1,1) =  (u(2,2)*u(3,3)-u(2,3)*u(3,2)) /volu
        x(1,2) = -(u(2,1)*u(3,3)-u(2,3)*u(3,1)) /volu
        x(1,3) =  (u(2,1)*u(3,2)-u(2,2)*u(3,1)) /volu   ! 11 12 13
        x(2,1) = -(u(1,2)*u(3,3)-u(1,3)*u(3,2)) /volu   ! 21 22 23
        x(2,2) =  (u(1,1)*u(3,3)-u(1,3)*u(3,1)) /volu   ! 31 32 33
        x(2,3) = -(u(1,1)*u(3,2)-u(1,2)*u(3,1)) /volu
        x(3,1) =  (u(1,2)*u(2,3)-u(1,3)*u(2,2)) /volu
        x(3,2) = -(u(1,1)*u(2,3)-u(1,3)*u(2,1)) /volu
        x(3,3) =  (u(1,1)*u(2,2)-u(1,2)*u(2,1)) /volu
        call TransMat(x,v)
      endif
      return
      end
      integer function length(str)
      implicit none
      character str*(*)
      integer   ic
      integer   i
      do i=len(str),1,-1
        ic = ichar(str(i:i))
        if(ic.ne.ichar(' ').and.ic.ne.0) then
          length = i
          return
        endif
      enddo
      length = 0
      return
      end ! length
      integer function lenstr(s)
      implicit none
      character s*(*)
      integer   length
      lenstr = max(1,length(s))
      return
      end ! lenstr
      subroutine lowercase(string1,string2)
      implicit none
      character string1*(*)
      character string2*(*)
      integer   length
      character c*1
      integer   i
      integer   delta
      delta = ichar('a')-ichar('A')
      string2 = string1
      do 10 i=1,length(string2)
        c = string2(i:i)
        if(c.ge.'A'.and.c.le.'Z') then
          string2(i:i) = char( ichar(c)+delta)
        endif
10    continue
      return
      end
      subroutine MakeViewMat(v,m)
      implicit none
      real    v(3)     ! I
      real    m(3,3)   ! O
      real    Ax(3)
      real    Ay(3)
      real    Az(3)
      real    f
      integer normerror
      call NormVec(v,Az,normerror)
      if(normerror.ne.0) then
        call unit_matrix(m)
        return
      endif
      f = sqrt(Az(1)**2 + Az(2)**2)
      if(f.gt.0.00001745) then
        call Build_Vector(-Az(2)/f, Az(1)/f, 0.0, Ax)
      else
        call Build_Vector(0.0, 1.0, 0.0, Ax)
      endif
      call VecProd(Az,Ax,Ay)
      call Vec2Row(Ax,m,1)
      call Vec2Row(Ay,m,2)
      call Vec2Row(Az,m,3)
      return
      end ! MakeViewMat
      subroutine MatMat(r,s,t)
      implicit none
      real r(3,3)
      real s(3,3)
      real t(3,3)
      real u(3,3) ! temporary result
      integer i,j,k
      real sum
      do i=1,3
        do j=1,3
          sum = 0.0
          do k=1,3
            sum = sum + r(i,k)*s(k,j)
          enddo
          u(i,j) = sum
        enddo
      enddo
      call CopyMat(u,t)
      return
      end
      subroutine MatVec(r,v,u)
      implicit none
      real r(3,3)
      real v(3)
      real u(3)
      real x(3)   ! temp result
      real sum
      integer i,j
      do i=1,3
        sum = 0.0
        do j=1,3
          sum = sum + r(i,j)*v(j)
        enddo
        x(i) = sum
      enddo
      call CopyVec(x,u)
      return
      end
      subroutine MatVecFIF(r,v,u)
      implicit none
      real    r(3,3)
      integer v(3)
      real    u(3)
      real    w(3)
      call CopyVecIF(v,w)
      call MatVec(r,w,u)
      return
      end
      real function MatVol(r)
      implicit none
      real r(3,3)
      MatVol = r(1,1)*r(2,2)*r(3,3) + ! 11 12 13 11 12
     1     r(1,2)*r(2,3)*r(3,1) + ! 21 22 23 21 22
     2     r(1,3)*r(2,1)*r(3,2) - ! 31 32 33 31 32
     3     r(3,1)*r(2,2)*r(1,3) -
     4     r(3,2)*r(2,3)*r(1,1) -
     5     r(3,3)*r(2,1)*r(1,2)
      return
      end
      subroutine more(delta,header)
      implicit none
      integer   delta
      character header*(*)
      integer   length
      integer   lh
      integer   iostat
      integer   ncol
      character c*1
      character mode*1
      integer   nout
      logical   question
      logical   init
      logical   interactive
      integer   nrow
      character formatstring*6
      integer   lf
      save nout,question,init,interactive,nrow,formatstring,lf
      data init /.true./
      if(init) then
        call get_mode(mode)
        interactive = (mode.eq.'I')
        init = .false.
        call get_term_size(ncol,nrow)
        if(nrow.lt.5) nrow = 5
        question = .true.
        nout = 0
        call str_build_format(6,'A',formatstring,lf)
      endif
      if(delta.lt.0) then
        lh = length(header)
        if(lh.gt.0) write (6,formatstring(1:lf)) header(1:lh)
      endif
      if(interactive) then
        if(delta.eq.0) then
          nout = 0
        else if(delta.lt.0) then
          nout = 1
        else
          nout = nout + delta
        endif
        if(nout.gt.nrow-2) then
          if(question) then
            call termline('Type return to continue >',c,iostat)
            call upcase(c,c)
            if(iostat.ne.0) c = 'A'
            if(c.eq.'A') then
              question = .false.
            else if(c.eq.'Q') then
              call exitfatal
            endif
          endif
          lh = length(header)
          if(lh.gt.0) then
            write (6,formatstring(1:lf)) header(1:lh)
            nout = 1
          else
            nout = 0
          endif
        endif
      endif
      return
      end ! more
      real function myran(iseed)
      implicit none
      integer iseed
      integer ia,ic,im
      parameter(ia=7141,ic=54773,im=259200)
      iseed=mod(iseed*ia+ic,im)
      myran=float(iseed)/float(im)
      return
      end
      subroutine mywait(delta)
      implicit none
      real delta
      call sleep(nint(delta))
      return
      end                       ! mywait
      subroutine netscape(s,ier)
      character s*(*)
      integer   ier
      character command1*256
      character command2*256
      logical   newwindow
      integer   pid
      save newwindow
      data newwindow /.true./
      if(newwindow) then
        command1 = 'netscape -remote "openURL(#,new-window)"'
      else
        command1 = 'netscape -remote "openURL(#)"'
      endif
      call str_string(s,command1,command1)
      call str_string_write(6,command1,'trying:#')
      call spawn(command1,ier)
      if(ier.ne.0) then
        if(.not.newwindow) then
          call str_write(6,'We seem to have lost netscape')
        endif
        command2 = 'netscape "#"'
        call str_string(s,command2,command2)
        call str_string_write(6,command2,'trying:#')
        call spawn_nowait(command2,pid,ier)
      endif
      newwindow=.false.
      return
      end                       ! netscape
      subroutine NormVec(v,w,ier)
      implicit none
      real    v(3)
      real    w(3)
      integer ier
      real AbsVec
      real s
      s = AbsVec(v)
      if(s.lt.1.0e-8) then   ! 1.0e-15
        ier = 1
      else
        call FacVec(1.0/s,v,w)
        ier = 0
      endif
      return
      end
      subroutine open_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      integer   lenstr
      character filename*256
      integer   lf
      filename = fn
      lf = lenstr(filename)
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_string(filename,'No free unit in open_file #',
     1   message)
        return
      endif
      open(unit=unit,file=filename(1:lf),status='old',iostat=error)
      if(error.ne.0) then
        call str_integer(error,'Error # opening #',message)
        call str_string(filename,message,message)
      else
        message = 'Opened '//filename(1:lf)
      endif
      return
      end ! open_file
      logical function OutputToScreen()
      implicit none
      integer   lastmode
      save lastmode
      data lastmode /-1/
      if(lastmode.eq.-1) then
        call myoutputmode(lastmode)
      endif
      OutputToScreen = (lastmode.eq.1)
      return
      end ! get_mode
      subroutine PosVec(v,vlist,ntot,tol,npos)
      real    v(3)
      real    vlist(3,*)
      integer ntot
      real    tol
      integer npos
      logical SameVec
      integer i
      real    w(3)
      do i=1,ntot
        call getVec(vlist,i,w)
        if(SameVec(v,w,tol)) then
          npos = i
          return
        endif
      enddo
      npos = 0
      return
      end
      subroutine PosVecI(v,vlist,ntot,npos)
      integer v(3)
      integer vlist(3,*)
      integer ntot
      integer npos
      integer i
      do i=1,ntot
        if(v(1).eq.vlist(1,i).and.v(2).eq.vlist(2,i).and.
     +       v(3).eq.vlist(3,i)) then
          npos = i
          return
        endif
      enddo
      npos = 0
      return
      end
      subroutine put_inp(dd)
      implicit none
      character dd*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if (FirstTime) call get_inp_init(-5)
      if(PutbufferPointer.ge.MaxPutbuffer) then
        if(nerr.gt.0) call str_integer_write(nerr,MaxPutbuffer,
     +       'Get_inp: put buffer overflow. Maximum = #')
        if(AbortOnError) call exitfatal
        return
      endif
      PutbufferPointer = PutbufferPointer + 1
      putbuffer(PutbufferPointer) = dd
      return
      end ! put_inp
      subroutine randomize(seed)
      implicit none
      integer seed
      character rolex*10
      character t*10
      integer n1,n2,n3
      t = rolex()
      read(t,100) n1,n2,n3
100   format(1x,i2,1x,i2,1x,i2)
      seed = (n1*n2*n3*2)+1
      call randseed(seed)
      return
      end ! randomize
      subroutine RandSeed(s)
      implicit none
      integer s
      integer seed
      common /rnd___random/ seed
      seed = s
      return
      end ! randseed
      subroutine rename_file(file1,file2,ier)
      implicit none
      character file1*(*)
      character file2*(*)
      integer ier
      integer   lenstr
      integer   myrename
      character f1*256
      character f2*256
      integer   lf1
      integer   lf2
      f1 = file1
      f2 = file2
      lf1 = lenstr(f1)
      lf2 = lenstr(f2)
      call rename_unique_file(f2(1:lf2))
      ier = myrename(f1(1:lf1),f2(1:lf2))
      return
      end ! rename_file
      subroutine rename_unique_file(in)
      implicit none
      character in*(*)
      integer   lenstr
      integer   myrename
      integer   get_str_unit
      integer   li
      character f*256
      integer   lf
      logical   exist
      integer   ic
      character template*256
      integer   lt
      integer   ier
      li = lenstr(in)
      template = in
      lt = li
      lf = 0
      inquire(file=template(1:lt),exist=exist)
      if(.not.exist) return
      ic = 0
      template(lt+1:lt+4) = '.~#~'
      lt = lt + 4
      do while(exist)
        ic = ic + 1
        call str_integer(ic,template,f)
        lf = lenstr(f)
        inquire(file=f(1:lf),exist=exist)
      enddo
      if(get_str_unit().eq.6) call str_flush
      call str_2string_write(6,in(1:li),f(1:lf),
     +     'WARNING: renaming existing file # into #')
      ier = myrename(in(1:li),f(1:lf))
      return
      end
      subroutine resetinterrupt
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      data selfinterrupt,action,stackp /0,0,0/
      if (action.gt.0) then
        selfinterrupt = 0
        call setcc
      endif
      return
      end
      real function Rnd()
      implicit none
      real    myran
      integer seed
      common /rnd___random/ seed
      data seed /0/
      if(seed.eq.0) call randomize(seed)
      rnd = myran(seed)
      return
      end ! rnd
      character*10 function rolex()
      implicit none
      character hlp*20
      integer   len
      call ctimestr(hlp,len)
      rolex = ' '//hlp(1:8)//' '
      return
      end                       ! rolex
      subroutine RotateMat(rold,rotvec,rotang,rnew)
      implicit none
      real rold(3,3)
      real rotvec(3)
      real rotang
      real rnew(3,3)
      real rotmat(3,3)
      call GeneralRotMat(rotvec,rotang,rotmat)
      call MatMat(rotmat,rold,rnew)
      return
      end
      subroutine Row2Vec(rown,m,v)
      implicit none
      integer rown
      real    m(3,3)
      real    v(3)
      integer i
      do i=1,3
        v(i) = m(rown,i)
      enddo
      return
      end
      logical function SameVec(v1,v2,tol)
      real    v1(3)
      real    v2(3)
      real    tol
      integer i
      real    diff
      do i=1,3
        diff = abs(v1(i) - v2(i))
        if(diff.gt.tol) then
          SameVec = .false.
          return
        endif
      enddo
      SameVec = .true.
      return
      end
      logical function SameVecI(v1,v2)
      integer v1(3)
      integer v2(3)
      integer i
      do i=1,3
        if(v1(i)-v2(i).ne.0) then
          SameVecI = .false.
          return
        endif
      enddo
      SameVecI = .true.
      return
      end
      subroutine savemat(u,v,n)
      implicit none
      real    u(3,3)
      real    v(3,3,*)
      integer n
      integer i
      integer j
      do j=1,3
        do i=1,3
          v(i,j,n)= u(i,j)
        enddo
      enddo
      return
      end
      subroutine SaveVec(v,s,n)
      implicit none
      real    v(3)
      real    s(3,*)
      integer n
      integer i
      do i=1,3
        s(i,n) = v(i)
      enddo
      return
      end
      subroutine SaveVecI(v,s,n)
      implicit none
      integer    v(3)
      integer    s(3,*)
      integer n
      integer i
      do i=1,3
        s(i,n) = v(i)
      enddo
      return
      end
      real function ScalProd(u,v)
      implicit none
      real u(3)
      real v(3)
      ScalProd = u(1)*v(1) + u(2)*v(2) + u(3)*v(3)
      return
      end
      character*13 function sec2time(t)
      implicit none
      real      t
      integer   days
      integer   minutes
      integer   hours
      integer   seconds
      integer   n
      integer   ioerr
      character dummy*13
      n = nint(t)
      seconds = mod(n,60)
      n = n/60
      minutes = mod(n,60)
      n = n/60
      hours = mod(n,24)
      days = n/24
      write(dummy,100,iostat=ioerr) days,hours,minutes,seconds
100   format(i4.0,1x,i2.2,':',i2.2,':',i2.2)
      sec2time = dummy
      return
      end                       ! sec2time
      real function second()
      implicit none
      integer msec
      common /my___timer/ msec
      integer cpu
      call get___cputime(1,cpu)
      second = 0.01 *(float(cpu-msec)+0.5)
      return
      end                       ! second
      subroutine set_default_directory(new,old,ier)
      implicit none
      character new*(*)
      character old*(*)
      integer ier
      integer   length
      integerchdir
      character n*256
      integer   ln
      n = new
      ln = length(n)
      call get_default_directory(old,ier)
      ier = chdir(n(1:ln))
      return
      end ! set_default_directory
      subroutine set_files(n1,n2,n3,n4)
      implicit none
      integer n1,n2,n3,n4
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   long,medium,short
      parameter (long=256)
      parameter (medium=80)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      integer iALIAS,iAll,iATTACH,iBACK,iBELL,iCD,iCLS,iCOMMAND,
     +     iCPU,iDATE
      parameter (iALIAS = 1)
      parameter (iALL = iAlIAS+1)
      parameter (iATTACH = iALL+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iCD = iBELL+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iGETPL,iGETPLR,iGOTO,iHELP,iHELPG,iHELPL,iIF
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iGETPL = iEXPORT+1)
      parameter (iGETPLR = iGETPL+1)
      parameter (iGOTO = iGETPLR+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      parameter (iIF = iHELPL+1)
      integer iIMPORT,iJOURNAL,iLISTPL,iMKDIR,iOPTPL,iPAUSE,iPREFIX
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTPL = iJOURNAL+1)
      parameter (iMKDIR = iLISTPL+1)
      parameter (iOPTPL = iMKDIR+1)
      parameter (iPAUSE = iOPTPL+1)
      parameter (iPREFIX = iPAUSE+1)
      integer iRENAME,iREPEAT,iSECOND,iSETCPU,iSETEOF,iSETPL,iSETPLR
      parameter (iRENAME = iPREFIX+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      parameter (iSETPL = iSETEOF+1)
      parameter (iSETPLR = iSETPL+1)
      integer   iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETPLR+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iUNALIAS,iVMS,iWAIT,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iUNALIAS = iTIME+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWL = iWAIT+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,ninp,nout,nerr,
     +     nlog,InitBusy,EchoStatus
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,LocalUpcase,gotoactive,
     +     AbortOnError,AllowAlldefault,AllDefault
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName
      if (n2.ge.0) nout = n2
      if (n3.ge.0) nerr = n3
      if (n4.ge.0) nlog = n4
      if (n1.gt.0) then
        if(ninp.gt.0) call get_inp_close_internal(ninp)
        call get_newline
      else if(n1.eq.0) then
        if(ninp.gt.0) call get_inp_close_internal(ninp)
        ninp = 0
      endif
      if (FirstTime) then
        if (n1.ge.0) then
          call get_inp_init(0)
        else
          call get_inp_init(-5)
        endif
      endif
      return
      end ! set_files
      subroutine set_symbol(symbol,value)
      implicit none
      character symbol*(*)
      character value*(*)
      integer   ier
      integer   lenstr
      integermyputenv
      character line*256
      integer   ls,lv
      ls = lenstr(symbol)
      lv = lenstr(value)
      line = symbol(1:ls)//'='//value(1:lv)
      ier = myputenv(line)
      if(ier.ne.0) write (*,*) 'set_symbol failed'
      return
      end
      subroutine settime
      implicit none
      integer msec
      common /my___timer/ msec
      data msec /0/
      call get___cputime(2,msec)
      return
      end                       ! settime
      subroutine shell(ier)
      implicit none
      integer   ier
      integer   length
      integer   ls
      character shellname*80
      call getenv('SHELL',shellname)
      ls = length(shellname)
      call spawn(shellname(1:ls),ier)
      return
      end ! shell
      real*8 function signedfactor()
      implicit none
      real*8    eval_factor
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      if (ch.eq.'-') then
        call eval_nextch
        signedfactor=-eval_factor()
        if (err.gt.0) return
      ELSE
        signedfactor=eval_factor()
        if (err.gt.0) return
      endif
      return
      end ! signedfactor
      real*8 function simple_expression()
      implicit none
      real*8    eval_term
      integer   pos
      integer   err
      integer   lf
      common/evl___evaluate/pos,err,lf
      character form*255
      character ch
      character reason*25
      common/evl___evaluate_char/form,ch,reason
      integer   isim
      common/evl___simple/isim
      real*8    s
      real*8    s2
      common/evl___simple_real/s(20),s2(20)
      character ops
      common/evl___simple_char/ops(20)
      simple_expression = 0.0D0 ! init
      isim=isim+1
      if (isim.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      s(isim)=eval_term()
      if (err.gt.0) return
      do while (ch.eq.'*'.or.ch.eq.'/')
        ops(isim)=ch
        call eval_nextch
        if (ops(isim).eq.'*') then
          s(isim)=s(isim)*eval_term()
          if (err.gt.0) return
        else
          s2(isim)=eval_term()
          if (s2(isim).eq.0) then
            reason='divide overflow'
            err=pos
            return
          endif
          s(isim)=s(isim)/s2(isim)
          if (err.gt.0) return
        endif
      enddo
      simple_expression=s(isim)
      isim=isim-1
      return
      end ! simple_expression
      subroutine sort_char(n,ra)
      implicit none
      integer   n           ! input
      character ra(*)*(*)   ! input and output
      integer   l
      integer   ir
      character rra*256
      integer   i
      integer   j
      if(n.le.1) return
      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j).lt.ra(j+1))j=j+1
          endif
          if(rra.lt.ra(j))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ra(i)=rra
      go to 10
      end ! sort_char
      subroutine sort_real_index(n,ra,ira)
      implicit none
      integer n        ! input
      real    ra(*)    ! input
      integer ira(*)   ! output
      integer i
      integer l
      integer ir
      real    rra
      integer irra
      integer j
      do i=1,n
        ira(i) = i
      enddo
      if(n.le.1) return
      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          irra=ira(l)
          rra=ra(irra)
        else
          irra=ira(ir)
          rra=ra(irra)
          ira(ir)=ira(1)
          ir=ir-1
          if(ir.eq.1)then
            ira(1)=irra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(ira(j)).lt.ra(ira(j+1)))j=j+1
          endif
          if(rra.lt.ra(ira(j)))then
            ira(i)=ira(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ira(i)=irra
      go to 10
      end ! sort_real_index
      subroutine spawn(command,ier)
      implicit none
      character command*(*)
      integer   ier
      character c*256
      integer   length
      integer   lc
      integer   system
      external  system
      lc=length(command)
      c = command(1:lc)
      ier=system(c(1:lc))
      if(ier.ne.0) then
        call str_integer_out(ier,'SPAWN error #')
        call str_out('after')
        call str_out(c(1:lc))
        call str_flush
      endif
      return
      end ! spawn
      subroutine spawn_nowait(command,pid,ier)
      implicit none
      character command*(*)
      integer   pid
      integer   ier
      integer   length
      integer   lc
      character c*256
      lc=length(command)
      c = command(1:lc)
      lc = lc + 1
      c(lc:lc)='&'
      call spawn(c(1:lc),ier)
      pid=0
      return
      end ! spawn_nowait
      subroutine spawncc(command,ier)
      implicit none
      character command*(*)
      integer   ier
      character c*256
      integer   length
      integer   lc
      integer   system
      external  system
      lc=length(command)
      c = command(1:lc)
      ier=system(c(1:lc))
      if(mod(ier,128).eq.2) call ccself
      if(ier.ne.0) then
        call str_integer_out(ier,'SPAWN error #')
        call str_integer_out(mod(ier,128),'mod(ier,128)=#')
        call str_out('after')
        call str_out(c(1:lc))
        call str_out('Calling ccself')
        call ccself
        call str_flush
      endif
      return
      end                       ! spawncc
      subroutine str_1substitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*(*)        ! string to change. No Empty string
      character new*(*)        ! into this one.    Empty string allowed
      character destination*(*)! output
      integer   length
      integer   KL         ! length old
      integer   i
      integer   KN         ! length new
      integer   ls
      character tmp*256
      integer   lt
      ls = length(source)
      if(ls.eq.0) then
        destination = source(1:ls)
        return
      endif
      KL = len(old)-1
      if(KL.le.0) then
        destination = source(1:ls)
        return
      endif
      i = index(source(1:ls),old(1:KL))
      if(i.eq.0) then
        destination = source(1:ls)
        return
      endif
      KN = length(new) - 1  ! hier stond len 160896
      if(KN.lt.0) then
        destination = source(1:ls)
        return
      endif
      if(kn.eq.0) then
        if(i.gt.1) then
          tmp = source(1:i-1)
          lt = i-1
        else
          lt = 0
        endif
      else
        if(i.gt.1) then
          tmp = source(1:i-1)//new(1:kn)
          lt = i-1+kn
        else
          tmp = new(1:kn)
          lt = kn
        endif
      endif
      if(i+kl.le.ls) then
        if(lt.gt.0) then
          tmp = tmp(1:lt)//source(i+kl:ls)
	else
          tmp = source(i+kl:ls)
        endif
      endif
      destination = tmp
      return
      end ! str_1substitute
      subroutine str_2integer(n1,n2,s,dest)
      implicit none
      integer   n1,n2
      character s*(*)
      character dest*(*)
      integer ir(2)
      ir(1) = n1
      ir(2) = n2
      call str_iarray(2,ir,s,dest)
      return
      end ! str_2integer
      subroutine str_2integer_out(n1,n2,s)
      implicit none
      integer   n1,n2
      character s*(*)
      character line*256
      call str_2integer(n1,n2,s,line)
      call str_out(line)
      return
      end ! str_2integer_out
      subroutine str_2integer_write(unit,n1,n2,s)
      implicit none
      integer   unit
      integer   n1,n2
      character s*(*)
      character line*256
      call str_2integer(n1,n2,s,line)
      call str_write(unit,line)
      return
      end ! str_2integer_write
      subroutine str_2real(r1,r2,s,dest)
      implicit none
      real      r1,r2
      character s*(*)
      character dest*(*)
      real      r(2)
      r(1) = r1
      r(2) = r2
      call str_array(2,r,s,dest)
      return
      end ! str_2real
      subroutine str_2real_out(r1,r2,s)
      implicit none
      real      r1,r2
      character s*(*)
      character line*256
      call str_2real(r1,r2,s,line)
      call str_out(line)
      return
      end ! str_2real_out
      subroutine str_2string(string1,string2,s,dest)
      implicit none
      character string1*(*)
      character string2*(*)
      character s*(*)
      character dest*(*)
      character temp*256
      call str_string(string1,s,temp)
      call str_string(string2,temp,dest)
      return
      end ! str_2string
      subroutine str_2string_write(unit,string1,string2,s)
      implicit none
      integer   unit
      character string1*(*)
      character string2*(*)
      character s*(*)
      character line*256
      call str_2string(string1,string2,s,line)
      call str_write(unit,line)
      return
      end ! str_2string_write
      subroutine str_3integer(n1,n2,n3,s,dest)
      implicit none
      integer   n1,n2,n3
      character s*(*)
      character dest*(*)
      integer ir(3)
      ir(1) = n1
      ir(2) = n2
      ir(3) = n3
      call str_iarray(3,ir,s,dest)
      return
      end ! str_3integer
      subroutine str_3integer_out(n1,n2,n3,s)
      implicit none
      integer   n1,n2,n3
      character s*(*)
      character line*256
      call str_3integer(n1,n2,n3,s,line)
      call str_out(line)
      return
      end ! str_3integer_out
      subroutine str_3string(string1,string2,string3,s,dest)
      implicit none
      character string1*(*)
      character string2*(*)
      character string3*(*)
      character s*(*)
      character dest*(*)
      character temp*256
      call str_string(string1,s,temp)
      call str_string(string2,temp,temp)
      call str_string(string3,temp,dest)
      return
      end ! str_3string
      subroutine str_3string_write(unit,string1,string2,string3,s)
      implicit none
      integer   unit
      character string1*(*)
      character string2*(*)
      character string3*(*)
      character s*(*)
      character line*256
      call str_3string(string1,string2,string3,s,line)
      call str_write(unit,line)
      return
      end ! str_3string_write
      subroutine str_array(n,r,s,dest)
      implicit none
      integer   n
      real      r(n)
      character s*(*)
      character dest*(*)
      integer   lenstr
      integer   length
      character local*20
      integer   i
      logical   special
      character hek*20
      integer   L
      character c*1
      c = ';'
      dest = s
      call str_fill(hek,n,'#')
      special = (index(dest,hek(1:n)).eq.0)
      if(length(dest).eq.0) then
        dest = '#'
        do i=2,n
          dest = dest(1:lenstr(dest))//' #'
        enddo
        special = .true.
      else if(index(dest,'#').eq.0) then
        do i=1,n
          dest = dest(1:lenstr(dest))//' #'
        enddo
        special = .true.
      endif
      if(special) then
        do i=1,n
          call str_real_internal(r(i),local,L)
          call str_1substitute(dest,'#'//c,local(1:L)//c,dest)
        enddo
      else
        do i=n,1,-1
          call str_real_internal(r(i),local,L)
          call str_1substitute(dest,hek(1:i)//c,local(1:L)//c,dest)
        enddo
      endif
      return
      end ! str_array
      subroutine str_array_out(n,r,s)
      implicit none
      integer   n
      real      r(n)
      character s*(*)
      character line*256
      call str_array(n,r,s,line)
      call str_out(line)
      return
      end ! str_array_out
      subroutine str_build_format(unit,s1,s2,ls2)
      implicit none
      integer   unit
      character s1*(*)
      character s2*(*)
      integer   ls2
      integer   lenstr
      call str_string(s1,'(#)',s2)
      ls2 = lenstr(s2)
      return
      end ! str_build_format
      subroutine str_charsubstitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*1          ! string to change. No Empty string
      character new*1          ! into this one.    Empty string allowed
      character destination*(*)! output
      integer   length
      integer   i
      integer   K
      integer   ls
      destination = source
      ls = length(source)
      if(ls.eq.0) return
      if(old.eq.new) return
      k = index(destination(1:ls),old)
      if(k.eq.0) return
      do i=k,ls
        if(destination(i:i).eq.old) then
          destination(i:i) = new
        endif
      enddo
      return
      end ! str_charsubstitute
      subroutine str_collapse(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   i
      integer   j
      integer   ic
      j=0
      do i=1,len(source)
        ic=ichar(source(i:i))
        if (ic.ne.0.and.ic.ne.9.and.ic.ne.32) then
          j=j+1
          destination(j:j)=source(i:i)
          if (j.ge.len(destination)) return
        endif
      enddo
      destination(j+1:)=' '
      return
      end ! str_collapse
      integer function str_compress(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   i
      integer   j
      integer   ic
      logical   addspace
      integer   ld
      j=0
      ld = len(destination)
      addspace = .false.
      do i=1,len(source)
        ic=ichar(source(i:i))
        if (ic.eq.0.or.ic.eq.32) then
          if(j.gt.0) addspace = .true.
        else
          if(addspace) then
            j=j+1
            destination(j:j)=' '
            if (j.ge.ld) then
              str_compress = ld - 1
              return
            endif
            addspace = .false.
          endif
          j=j+1
          destination(j:j)=source(i:i)
          if (j.ge.ld) then
            str_compress = ld
            return
          endif
        endif
      enddo
      destination(j+1:)=' '
      str_compress = j
      return
      end ! str_compress
      subroutine str_concat(s1,s2,s3)
      implicit none
      character s1*(*)
      character s2*(*)
      character s3*(*)
      integer   length
      integer   ls1
      ls1 = length(s1)
      if(ls1.eq.0) then
        s3 = s2
      else
        s3 = s1(1:ls1)//s2
      endif
      return
      end ! str_concat
      logical function str_equal(s1,s2)
      character s1*(*)
      character s2*(*)
      integer   length
      integer   L
      logical   b
      character u1*256
      character u2*256
      L = min(length(s1),length(s2))
      if(L.eq.0) then
        b = .false.
      else
        call upcase(s1(1:L),u1)
        call upcase(s2(1:L),u2)
        b = (u1(1:L).eq.u2(1:L))
      endif
      str_equal = b
      return
      end ! str_equal
      subroutine str_extract(source,n,destination)
      implicit none
      character source*(*)
      integer   n
      character destination*(*)
      integer   str_compress
      character line*256
      integer   p1,p2
      integer   i
      integer   nc
      nc = str_compress(source,line)
      destination = ' '
      if(n.le.0) return
      p1 = 1
      p2 = index(line(p1:),' ')
      do i=2,n
        p1 = p1+p2
        p2 = index(line(p1:),' ')
      enddo
      if (p2.gt.0) then
        destination = line(p1:p1+p2-1)
      else
        destination = ' '
      endif
      return
      end ! str_extract
      subroutine str_fill(s,n,c)
      implicit none
      character s*(*)
      integer   n
      character c*1
      integer   i
      s = ' '
      do i=1,min(n,len(s))
        s(i:i) = c
      enddo
      return
      end ! str_fill
      subroutine str_flush
      implicit none
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      if(lb.gt.0) then
        if(unit.eq.6) then
          if(str_more_active) call more(1,' ')
          if(append_length.gt.0) then
            call displays(append_string(1:append_length))
          endif
          write(unit,'()')
        else
          if(append_length.eq.0) then
            write (unit,flush_format(1:lff)) str_buffer(1:lb)
          else
            write (unit,flush_format(1:lff)) str_buffer(1:lb)//
     1           append_string(1:append_length)
          endif
        endif
        lb = 0
      endif
      return
      end ! str_flush
      subroutine str_grad(r,s,dest)
      implicit none
      real      r
      character s*(*)
      character dest*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      call str_real(grad*r,s,dest)
      return
      end ! str_grad
      subroutine str_grad_out(r,s)
      implicit none
      real      r
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      call str_real_out(grad*r,s)
      return
      end ! str_grad_out
      subroutine str_gradvector(v,s,dest)
      implicit none
      real      v(3)
      character s*(*)
      character dest*(*)
      real      w(3)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      call facvec(grad,v,w)
      call str_array(3,w,s,dest)
      return
      end ! str_vector
      subroutine str_gradvector_out(v,s)
      implicit none
      real      v(3)
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      real      w(3)
      call facvec(grad,v,w)
      call str_array_out(3,w,s)
      return
      end ! str_vector_out
      subroutine str_header(source,field,new_source)
      implicit none
      character source*(*)
      character field*(*)
      character new_source*(*)
      character line*256
      integer   i
      call str_leading(source,line)
      i = index(line,' ')
      if(i.gt.1) then
        field = line(1:i-1)
        call str_leading(line(i:),new_source)
      else
        field = ' '
        new_source = line
      endif
      return
      end ! str_header
      subroutine str_iarray(n,ir,s,dest)
      implicit none
      integer   n
      integer   ir(n)
      character s*(*)
      character dest*(*)
      integer   lenstr
      integer   length
      integer   ioerr
      character local*20
      integer   i
      logical   special
      character hek*20
      integer   L
      character c*1
      c= ';'
      dest = s
      call str_fill(hek,n,'#')
      special = (index(s,hek(1:n)).eq.0)
      if(length(dest).eq.0) then
        dest = '#'
        do i=2,n
          dest = dest(1:lenstr(dest))//' #'
        enddo
        special = .true.
      else if(index(s,'#').eq.0) then
        do i=1,n
          dest = dest(1:lenstr(dest))//' #'
        enddo
        special = .true.
      endif
      if(special) then
        do i=1,n
          write (local,*,iostat=ioerr) ir(i)
          call str_leading(local,local)
          L = length(local)
          call str_1substitute(dest,'#'//c,local(1:L)//c,dest)
        enddo
      else
        do i=n,1,-1
          write (local,*,iostat=ioerr) ir(i)
          call str_leading(local,local)
          L = length(local)
          call str_1substitute(dest,hek(1:i)//c,local(1:L)//c,dest)
        enddo
      endif
      return
      end ! str_iarray
      subroutine str_iarray_out(n,ir,s)
      implicit none
      integer   n
      integer   ir(n)
      character s*(*)
      character line*256
      call str_iarray(n,ir,s,line)
      call str_out(line)
      return
      end ! str_iarray_out
      subroutine str_indent(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      if(n.ge.0) indent = n
      if(indent.gt.0) then
        call str_integer(indent,'#X,A',flush_format)
      else
        flush_format = 'A'
      endif
      call str_build_format(unit,flush_format,flush_format,lff)
      return
      end ! str_indent
      subroutine str_integer(n,s,dest)
      implicit none
      integer   n
      character s*(*)
      character dest*(*)
      integer   length
      integer   lenstr
      integer   ioerr
      character local*20
      integer   L
      character c*1
      c = ';'
      dest = s
      if(length(dest).eq.0) then
        dest = '#'
      else if(index(dest,'#').eq.0) then
        dest = dest(1:lenstr(dest))//' #'
      endif
      write (local,*,iostat=ioerr) n
      call str_leading(local,local)
      L = length(local)
      call str_1substitute(dest,'#'//c,local(1:L)//c,dest)
      return
      end ! str_integer
      subroutine str_integer_out(n,s)
      implicit none
      integer   n
      character s*(*)
      character line*256
      call str_integer(n,s,line)
      call str_out(line)
      return
      end ! str_integer_out
      subroutine str_integer_write(unit,n,s)
      implicit none
      integer   unit
      integer   n
      character s*(*)
      character line*256
      call str_integer(n,s,line)
      call str_write(unit,line)
      return
      end ! str_integer_write
      subroutine str_leading(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   length
      integer   i
      i = 1
      if(length(source).gt.0) then
        do while(source(i:i).eq.' ')
          i = i + 1
        enddo
      endif
      destination = source(i:)
      return
      end ! str_leading
      subroutine str_logical(b,s,dest)
      implicit none
      logical   b
      character s*(*)
      character dest*(*)
      integer   lenstr
      integer   length
      character c*1
      c = ';'
      dest = s
      if(length(dest).eq.0) then
        dest = '#'
      else if(index(dest,'#').eq.0) then
        dest = dest(1:lenstr(dest))//' #'
      endif
      if(b) then
        call str_1substitute(dest,'#'//c,'true'//c,dest)
      else
        call str_1substitute(dest,'#'//c,'false'//c,dest)
      endif
      return
      end ! str_logical
      subroutine str_logical_out(b,s)
      implicit none
      logical   b
      character s*(*)
      character line*256
      call str_logical(b,s,line)
      call str_out(line)
      return
      end ! str_logical_out
      subroutine str_logical_write(unit,b,s)
      implicit none
      integer   unit
      logical   b
      character s*(*)
      character line*256
      call str_logical(b,s,line)
      call str_write(unit,line)
      return
      end ! str_logical_write
      subroutine str_num(n,s,result)
      implicit none
      integer   n
      character s*(*)
      character result*(*)
      integer   str_compress
      character c*1
      integer   nc
      c = ';'
      if(index(s,'#').eq.0) then
        result = '# '//s
      else
        result = s
      endif
      if(n.eq.0) then
        call str_1substitute(result,'#'//c,'no'//c,result)
      else if(n.eq.1) then
        call str_1substitute(result,'#'//c,'one'//c,result)
      else
        call str_integer(n,result,result)
      endif
      if(n.eq.1) then
        call str_1substitute(result,'^'//c,c,result)
      else
        call str_1substitute(result,'^'//c,'s'//c,result)
      endif
      nc = str_compress(result,result)
      return
      end ! str_num
      subroutine str_num_out(n,s)
      implicit none
      integer   n
      character s*(*)
      character message*256
      call str_num(n,s,message)
      call str_out(message)
      return
      end ! str_num_out
      subroutine str_num_write(unit,n,s)
      implicit none
      integer   unit
      integer   n
      character s*(*)
      character message*256
      call str_num(n,s,message)
      call str_write(unit,message)
      return
      end ! str_num_write
      subroutine str_OnOff(b,s,dest)
      implicit none
      logical   b
      character s*(*)
      character dest*(*)
      integer   lenstr
      integer   length
      character c*1
      c = ';'
      dest = s
      if(length(dest).eq.0) then
        dest = '#'
      else if(index(dest,'#').eq.0) then
        dest = dest(1:lenstr(dest))//' #'
      endif
      if(b) then
        call str_1substitute(dest,'#'//c,'on'//c,dest)
      else
        call str_1substitute(dest,'#'//c,'off'//c,dest)
      endif
      return
      end ! str_OnOff
      subroutine str_OnOff_out(b,s)
      implicit none
      logical   b
      character s*(*)
      character line*256
      call str_OnOff(b,s,line)
      call str_out(line)
      return
      end ! str_OnOff_out
      subroutine str_out(string)
      implicit none
      character string*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer length
      integer   ls
      integer   i
      ls = length(string)
      if(ls.eq.0) return
      if(ls+lb+1+indent+append_length.ge.wrap) call str_flush
      if(lb.eq.0) then
        if(paragraph_length.ne.0) then
          if(unit.eq.6) then
            do i=1,indent
              call displayc(' ')
            enddo
            call displays(paragraph_string(1:paragraph_length))
            call displays(string(1:ls))
          else
            str_buffer = paragraph_string(1:paragraph_length)//
     1           string(1:ls)
          endif
          lb = paragraph_length + ls
        else
          if(unit.eq.6) then
            do i=1,indent
              call displayc(' ')
            enddo
            call displays(string(1:ls))
          else
            str_buffer =  string(1:ls)
          endif
          lb = ls
        endif
      else
        if(unit.eq.6) then
          call displayc(' ')
          call displays(string(1:ls))
        else
          str_buffer = str_buffer(1:lb)//' '// string(1:ls)
        endif
        lb = lb + ls + 1
      endif
      return
      end ! str_out
      subroutine str_real(r,s,dest)
      implicit none
      real      r
      character s*(*)
      character dest*(*)
      integer   lenstr
      integer   length
      character local*20
      integer   L
      character c*1
      c = ';'
      dest = s
      if(length(dest).eq.0) then
        dest = '#'
      else if (index(dest,'#').eq.0) then
        dest = dest(1:lenstr(dest))//' #'
      endif
      call str_real_internal(r,local,L)
      call str_1substitute(dest,'#'//c,local(1:L)//c,dest)
      return
      end ! str_real
      subroutine str_real_internal(r,dest,ld)
      implicit none
      real      r
      character dest*(*)
      integer   ld
      integer   real_len_max
      parameter (real_len_max=5)
      integer   real_len
      integer   real_len_stack(real_len_max)
      integer   real_len_p
      common /str___real_common/ real_len,real_len_stack,real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      integer   length
      integer   ioerr
      character local*20
      integer   L
      if(abs(r).lt.0.1.and.abs(r).gt.1.0e-5) then
        write (local,real_form1,iostat=ioerr) r
      else if(r.eq.0.0) then
        local = '0.0'
      else
        write (local,real_form2,iostat=ioerr) r
      endif
      call str_leading(local,local)
      l = length(local)
      do while(local(L:L).eq.'0')
        L = L - 1
      enddo
      if(local(L:L).eq.'.'.or.local(L:L).eq.'+') L = L + 1
      dest = local(1:L)
      ld = L
      return
      end ! str_real_internal
      subroutine str_real_len(n)
      implicit none
      integer   n
      integer   real_len_max
      parameter (real_len_max=5)
      integer   real_len
      integer   real_len_stack(real_len_max)
      integer   real_len_p
      common /str___real_common/ real_len,real_len_stack,real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      integer m
      data real_len /6/
      data real_len_p /0/
      data real_form1 /'(F14.6)'/
      data real_form2 /'(F20.6)'/
      if(n.eq.0) then
        m = 6
      else if(n.gt.0) then
        m = n
      else
        return
      endif
      if(m.gt.9) m = 9
      if(m.ne.real_len) then
        real_len = m
        write (real_form1,100) m
100     format('(F14.',i1,')')
        write (real_form2,100) m
110     format('(G20.',i1,')')
      endif
      return
      end ! str_real_len
      subroutine str_real_len_pop
      implicit none
      integer   real_len_max
      parameter (real_len_max=5)
      integer   real_len
      integer   real_len_stack(real_len_max)
      integer   real_len_p
      common /str___real_common/ real_len,real_len_stack,real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      integer m
      if(real_len_p.gt.0) then
        m = real_len_stack(real_len_p)
        real_len_p = real_len_p - 1
      else
        m = 6
      endif
      call str_real_len(m)
      return
      end ! str_real_len_pop
      subroutine str_real_len_push(n)
      implicit none
      integer n
      integer   real_len_max
      parameter (real_len_max=5)
      integer   real_len
      integer   real_len_stack(real_len_max)
      integer   real_len_p
      common /str___real_common/ real_len,real_len_stack,real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      integer   i
      real_len_p = real_len_p + 1
      if(real_len_p.gt.real_len_max) then
        do i=1,real_len_max-1
          real_len_stack(i) = real_len_stack(i+1)
        enddo
        real_len_p = real_len_max
      endif
      real_len_stack(real_len_p) = real_len
      call str_real_len(n)
      return
      end ! str_real_len_push
      subroutine str_real_out(r,s)
      implicit none
      real      r
      character s*(*)
      character line*256
      call str_real(r,s,line)
      call str_out(line)
      return
      end ! str_real_out
      subroutine str_real_write(unit,r,s)
      implicit none
      integer   unit
      real      r
      character s*(*)
      character line*256
      call str_real(r,s,line)
      call str_write(unit,line)
      return
      end ! str_real_write
      subroutine str_remove(source,remove,result)
      implicit none
      character source*(*)
      character remove*(*)
      character result*(*)
      integer   length
      integer   lr
      character toremove*256
      character c*1
      lr = length(remove)
      if(lr.eq.0) then
        result = source
      else
        c = ';'
        toremove = remove(1:lr)//c
        call str_substitute(source,toremove(1:lr+1),c,result)
      endif
      return
      end ! str_remove
      subroutine str_string(string,s,dest)
      implicit none
      character string*(*)
      character s*(*)
      character dest*(*)
      integer   length
      integer   lenstr
      integer   L
      character local*256
      character replace*256
      character c*1
      if(length(s).eq.0) then
        local = string
      else if(index(s,'#').eq.0) then
        local = s(1:lenstr(s))//' '//string(1:lenstr(string))
      else
        L = length(string)
        c = ';'
        if(L.eq.0) then
          call str_1substitute(s,'#'//c,c,local)
        else
          replace = string(1:L)//c
          call str_1substitute(s,'#'//c,replace,local)
        endif
      endif
      dest = local
      return
      end ! str_string
      subroutine str_string_out(string,s)
      implicit none
      character string*(*)
      character s*(*)
      character line*256
      call str_string(string,s,line)
      call str_out(line)
      return
      end ! str_string_out
      subroutine str_string_write(unit,string,s)
      implicit none
      integer   unit
      character string*(*)
      character s*(*)
      character line*256
      call str_string(string,s,line)
      call str_write(unit,line)
      return
      end ! str_string_write
      subroutine str_substitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*(*)        ! string to change. No Empty string
      character new*(*)        ! into this one.    Empty string allowed
      character destination*(*)! output
      integer   length
      integer   KL         ! length old
      integer   i
      integer   KN         ! length new
      integer   K
      integer   L
      character temp*1024   ! scratch
      integer   ls
      ls = length(source)
      if(ls.eq.0) then
        destination = source
        return
      endif
      KL = len(old)-1
      if(KL.le.0) then
        destination = source(1:ls)
        return
      endif
      i = index(source(1:ls),old(1:KL))
      if(i.eq.0) then
        destination = source(1:ls)
        return
      endif
      KN = len(new) - 1
      if(KN.lt.0) then
        destination = source(1:ls)
        return
      endif
      K = 1
      L = 1
      do while(k.le.ls)
        if(source(K:K+KL-1).eq.old(1:KL)) then
          if (kn.gt.0) then
            temp(L:L+KN-1) = new(1:kn)
          endif
          L = L + KN
          K = K + KL
        else
          temp(L:L) = source(K:K)
          L = L + 1
          K = K + 1
        endif
      enddo
      if(L.eq.1) then
        destination = temp(1:1)
      else
        destination = temp(1:L-1)
      endif
      return
      end ! str_substitute
      subroutine str_table(n,s,ls)
      implicit none
      integer   n
      character s(*)*(*)
      integer   ls
      integer   lenstr
      character mask*1024
      integer   i,j
      if(n.le.0) then
        ls = 1
        return
      endif
      ls = lenstr(s(1))
      do j=2,n
        ls = max(ls,lenstr(s(j)))
      enddo
      if(ls.gt.len(mask)) then
	call str_2integer_write(6,ls,len(mask),
     1   'WARNING:Table is too large. Length=#, Maximum allowed=#')
        ls = len(mask)
      endif
      mask = ' '
      do i=1,ls
        do j=1,n
          if(s(j)(i:i).ne.' ') then
            mask(i:i) = '*'
            goto 10
          endif
        enddo
        mask(i:i) = 's'
10      continue
      enddo
      i = 1
      do while(mask(i:i).eq.'s')
        i = i + 1
      enddo
      mask = mask(i:)
      do j=1,n
        s(j) = s(j)(i:)
      enddo
20    continue
      i = index(mask,'ss')
      if(i.eq.0) then
        ls = lenstr(mask)
        return
      endif
      mask = mask(1:i)//mask(i+2:)
      do j=1,n
        s(j)=s(j)(1:i)//s(j)(i+2:)
      enddo
      goto 20
      end ! str_table
      subroutine str_table_write(output_unit,n,s)
      implicit none
      integer   output_unit
      integer   n
      character s(*)*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer   length
      integer   gls,ls
      integer   i
      character form*80
      integer   lf
      if(n.le.0) return
      call str_build_format(output_unit,'A',form,lf)
      call str_table(n,s,gls)
      do i=1,n
        ls = length(s(i))
        if(ls.eq.0) then
          call str_fill(s(i),gls,'=')
          ls = gls
        endif
        if(str_more_active.and.output_unit.eq.6) call more(1,s(1))
        write (output_unit,form(1:lf)) s(i)(1:ls)
      enddo
      return
      end ! str_table_write
      subroutine str_unit(u)
      implicit none
      integer u
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer   page
      data unit   / 6/
      data wrap   /80/
      data wrap6  /0/
      data lb     / 0/
      data indent / 0/
      data flush_format /'(a)'/
      data lff /3/
      data unitp /0/
      data paragraph_length /0/
      data append_length /0/
      data str_more_active /.false./
      call str_flush  ! if there is anything left
      unit = u
      if(unit.eq.6) then
        if(wrap6.eq.0) then
          call get_term_size(wrap6,page)
          wrap6 = min(wrap6,132)
        endif
        wrap = wrap6
      else
        inquire(unit=unit,recl=wrap)
        if(wrap.eq.0) wrap=80
      endif
      wrap = min(wrap,len(str_buffer))
      if(indent.gt.0) then
        call str_integer(indent,'#X,A',flush_format)
      else
        flush_format = 'A'
      endif
      call str_build_format(unit,flush_format,flush_format,lff)
      return
      end ! str_unit
      subroutine str_unit_pop
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer   u
      if(unitp.gt.0) then
        u = unitstack(unitp)
        if(unit.ne.u) then
          call str_unit(u)
        else
          call str_flush
        endif
        unitp = unitp - 1
      else
        call str_write(6,'Unit Stack Underflow.')
      endif
      return
      end
      subroutine str_unit_push(u)
      integer   u
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer   i
      if(unitp.lt.maxunitstack) then
        unitp = unitp + 1
        unitstack(unitp) = unit
        if(unit.ne.u) then
          call str_unit(u)
        else
          call str_flush
        endif
      else
        call str_integer_write(6,maxunitstack,
     +       'Unit Stack Overflow. Max=#')
        do i=1,maxunitstack
          call str_2integer_write(6,i,unitstack(i),'i=# unit=#')
        enddo
      endif
      return
      end
      subroutine str_vector(v,s,dest)
      implicit none
      real      v(3)
      character s*(*)
      character dest*(*)
      call str_array(3,v,s,dest)
      return
      end ! str_vector
      subroutine str_vector_out(v,s)
      implicit none
      real      v(3)
      character s*(*)
      call str_array_out(3,v,s)
      return
      end ! str_vector_out
      subroutine str_word_count(s,n)
      implicit none
      character s*(*)
      integer   n
      integer   str_compress
      character line*256
      integer   i
      integer   ll
      ll = str_compress(s,line)
      n = 0
      if(ll.gt.0) then
        do i=1,ll
          if(line(i:i).eq.' ') n = n + 1
        enddo
        n = n + 1
      endif
      return
      end
      subroutine str_wrap(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer page
      if(n.le.0) then
        if(unit.eq.6) then
          call get_term_size(wrap6,page)
          wrap6 = min(wrap6,132)
          wrap = wrap6
        else
          inquire(unit=unit,recl=wrap)
          if(wrap.eq.0) wrap=80
        endif
      else
        wrap = n
      endif
      wrap = min(wrap,len(str_buffer))
      return
      end ! str_wrap
      subroutine str_write(output_unit,string)
      implicit none
      integer   output_unit
      character string*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      integer   lenstr
      integer   str_compress
      character s*256
      character form*80
      integer   lf
      integer   nc
      data write_compress /.true./
      if(write_compress) then
        nc = str_compress(string,s)
      else
        s = string
      endif
      if(indent.gt.0) then
        call str_integer(indent,'#X,A',form)
      else
        form = 'A'
      endif
      if(str_more_active.and.output_unit.eq.6) call more(1,' ')
      call str_build_format(output_unit,form,form,lf)
      write (output_unit,form(1:lf)) s(1:lenstr(s))
      return
      end ! str_write
      subroutine str_write_compress(set,previous)
      implicit none
      logical  set
      logical  previous
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      integer   lff
      integer   unitp
      integer   unitstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,indent,paragraph_length,
     +     append_length,str_more_active,lff,unitp,unitstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*256
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical tmp
      tmp = set
      previous = write_compress
      write_compress = tmp
      return
      end
      subroutine str_zero(s1,s2,ls2)
      character s1*(*)
      character s2*(*)
      integer   ls2
      integer    lenstr
      character zero*1
      integer   ls1
      zero = char(0)
      ls1 = lenstr(s1)
      s2 = s1(1:ls1)//zero
      ls2 = ls1 + 1
      return
      end
      subroutine SumVec(u,v,w)
      implicit none
      real    u(3)
      real    v(3)
      real    w(3)
      integer i
      do i=1,3
        w(i) = u(i) + v(i)
      enddo
      return
      end
      subroutine tableadd(line)
      character line*(*)
      integer maxtable
      parameter (maxtable=200)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*128
      common /table_com_char/ table
      if(itab.lt.maxtable) then
        itab = itab + 1
      else
        call tableflush
        itab = 1
      endif
      table(itab) = line
      return
      end                       ! tableadd
      subroutine tableflush
      integer maxtable
      parameter (maxtable=200)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*128
      common /table_com_char/ table
      integer lenstr
      integer i
      integer lt
      if(itab.gt.0) then
        do i=1,itab
          lt = lenstr(table(i))
          write (tableunit,600) table(i)(1:lt)
  600     format(a)
        enddo
        tableflushed = .true.
      endif
      return
      end                       ! tableflush
      subroutine tablestart(unit)
      integer unit
      integer maxtable
      parameter (maxtable=200)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*128
      common /table_com_char/ table
      tableunit = unit
      itab = 0
      tableflushed = .false.
      return
      end                       ! tablestart
      subroutine tablestop
      integer maxtable
      parameter (maxtable=200)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*128
      common /table_com_char/ table
      if(itab.gt.0) then
        if(tableflushed) then
          call tableflush
        else
          call str_table_write(tableunit,itab,table)
        endif
      endif
      return
      end                       ! tablestop
      subroutine termline(prompt,answer,ier)
      implicit none
      character prompt*(*)
      character answer*(*)
      integer   ier
      integer   length
      integer   i
      character c*1
      call get_mode(c)
      if(c.eq.'I') then
        do i=1,length(prompt)
          call displayc(prompt(i:i))
        enddo
        call displayc(' ')
        read (5,500,iostat=ier) answer
  500   format(a)
      else
        ier = 1
      endif
      return
      end
      character*11 function today()
      implicit none
      character hlp*9
      call date(hlp)
      if(hlp(8:8).ge.'5') then
        today = hlp(1:7)//'19'//hlp(8:9)
      else
        today = hlp(1:7)//'20'//hlp(8:9)
      endif
      return
      end                       ! today
      subroutine TooManyFatal(n1,n2,s)
      integer   n1
      integer   n2
      character s*(*)
      call str_flush
      call str_out('ERROR:')
      call str_out(s)
      if(n1.ne.n2) call str_integer_out(n1,'Value=#')
      call str_integer_out(n2,'Maximum=#.')
      call str_flush
      call exitfatal
      return
      end
      subroutine TransMat(u,v)
      implicit none
      real    u(3,3)
      real    v(3,3)
      real    x(3,3)
      integer i
      integer j
      do j=1,3
        do i=1,3
          x(i,j) = u(j,i)
        enddo
      enddo
      call CopyMat(x,v)
      return
      end
      subroutine uniquename(u)
      implicit none
      character u*(*)
      character rolex*10
      character t*20
      character s*20
      s = '##'
      call get_processname(t)
      call str_string(t,s,s)
      t = rolex()
      call str_substitute(t,':;',';',t)
      call str_string(t,s,s)
      call str_collapse(s,u)
      return
      end ! uniquename
      subroutine unit_matrix(m)
      implicit none
      real m(3,3)
      call Build_Matrix(1.0,0.0,0.0, 0.0,1.0,0.0, 0.0,0.0,1.0,m)
      return
      end
      subroutine upcase(string1,string2)
      implicit none
      character string1*(*)
      character string2*(*)
      integer   length
      character c*1
      integer   i
      integer   delta
      delta = ichar('a')-ichar('A')
      string2 = string1
      do 10 i=1,length(string2)
        c = string2(i:i)
        if(c.ge.'a'.and.c.le.'z') then
          string2(i:i) = char( ichar(c)-delta)
        endif
10    continue
      return
      end ! upcase
      subroutine Vec2Col(v,m,coln)
      implicit none
      real    v(3)
      real    m(3,3)
      integer coln
      integer i
      do i=1,3
        m(i,coln) = v(i)
      enddo
      return
      end
      subroutine Vec2Row(v,m,rown)
      implicit none
      real    v(3)
      real    m(3,3)
      integer rown
      integer i
      do i=1,3
        m(rown,i) = v(i)
      enddo
      return
      end
      subroutine VecProd(u,v,w)
      implicit none
      real u(3)
      real v(3)
      real w(3)
      real x(3)
      x(1) =   (u(2)*v(3) - u(3)*v(2))
      x(2) =   (u(3)*v(1) - u(1)*v(3))
      x(3) =   (u(1)*v(2) - u(2)*v(1))
      call CopyVec(x,w)
      return
      end
      subroutine Write2Mat(out,r1,r2,s1,s2)
      implicit none
      integer   out
      real      r1(3,3)
      real      r2(3,3)
      character s1*(*)
      character s2*(*)
      integer   Length
      real      MatVol
      character line*80
      integer   position
      integer   ls1
      integer   ls2
      integer   i
      integer   mwidth
      integer   mbetween
      parameter (mwidth=36)  ! 3*f12.7
      parameter (mbetween=5)
      integer   ioerr
      real      v1(3)
      real      v2(3)
      logical   cmprs
      call str_write_compress(.false.,cmprs)
      line = ' '
      ls1 = length(s1)
      if(ls1.gt.0) then
        position = int(0.5*(mwidth-ls1))
        line(position:) = s1
      endif
      ls2 = length(s2)
      if(ls2.gt.0) then
        position = int(0.5*(mwidth-ls2))
        line(mwidth+mbetween+position:) = s2
      endif
      if(length(line).gt.0) then
        call str_write(out,line)
      endif
      do i=1,3
        call row2vec(i,r1,v1)
        call row2vec(i,r2,v2)
        write (line,100,iostat=ioerr) v1,v2
100     format(3f12.7,5x,3f12.7)
        call str_write(out,line)
      enddo
      write (line,110,iostat=ioerr) MatVol(r1),MatVol(r2)
110   format('Determinant:',g15.7,9x,5x,12x,g15.7)
      call str_write(out,line)
      call str_write_compress(cmprs,cmprs)
      return
      end
      subroutine writecell(unit,dmat,s)
      implicit none
      integer   unit
      real      dmat(3,3)
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   length
      real      MatVol
      integer   str_compress
      character line*80
      integer   ll
      integer   ls
      integer   i
      real      a(3),al(3)
      call celldim(dmat,a,al)
      write (line,100) a,(Grad*al(i),i=1,3),matvol(dmat)
100   format(3f10.5,3f9.4,' V=',f10.2)
      ll = str_compress(line,line)
      ls = length(s)
      if(ls.ne.0) then
        line = s(1:ls)//':'//line
        call str_write(unit,line)
      else
        call str_write(unit,'Cell:'//line(1:ll))
      endif
      return
      end
      subroutine WriteMat(out,r,s)
      implicit none
      integer out
      real r(3,3)
      character s*(*)
      integer Length
      real MatVol
      integer   ioerr
      real      v(3)
      logical   cmprs
      character line*80
      call str_write_compress(.false.,cmprs)
      if(length(s).gt.0) call str_write(out,s)
      call Row2Vec(1,r,v)
      write (line,100,iostat=ioerr) v
100   format(3f12.7)
      call str_write(out,line)
      call Row2Vec(2,r,v)
      write (line,110,iostat=ioerr) v,matvol(r)
110   format(3f12.7,' Determinant:',g14.7)
      call str_write(out,line)
      call Row2Vec(3,r,v)
      write (line,100,iostat=ioerr) v
      call str_write(out,line)
      call str_write_compress(cmprs,cmprs)
      return
      end
